/* Indicator.c generated by valac 0.56.14, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
* Copyright (c) 2015-2018 elementary LLC (http://launchpad.net/wingpanel-indicator-network)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Library General Public License as published by
* the Free Software Foundation, either version 2.1 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include "network.h"
#include <gio/gio.h>
#include <glib.h>
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <granite.h>
#include <gmodule.h>

enum  {
	NETWORK_INDICATOR_0_PROPERTY,
	NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY,
	NETWORK_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* network_indicator_properties[NETWORK_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkIndicatorPrivate {
	NetworkWidgetsDisplayWidget* display_widget;
	NetworkWidgetsPopoverWidget* popover_widget;
	GNetworkMonitor* network_monitor;
	gboolean _is_in_session;
};

static gint NetworkIndicator_private_offset;
static gpointer network_indicator_parent_class = NULL;

static void network_indicator_on_state_changed (NetworkIndicator* self);
static void _network_indicator_on_state_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void __lambda35_ (NetworkIndicator* self);
static void ___lambda35__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                                 gpointer self);
static gboolean ___lambda36_ (NetworkIndicator* self,
                       GdkEventButton* event);
static void ___lambda37_ (NetworkIndicator* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda37__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean ____lambda36__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void network_indicator_update_tooltip (NetworkIndicator* self);
static void network_indicator_start_monitor (NetworkIndicator* self);
static GtkWidget* network_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* network_indicator_real_get_widget (WingpanelIndicator* base);
static void __lambda38_ (NetworkIndicator* self,
                  gboolean availabe);
static void ___lambda38__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                     gboolean network_available,
                                                     gpointer self);
static void network_indicator_real_opened (WingpanelIndicator* base);
static void network_indicator_real_closed (WingpanelIndicator* base);
static gchar* network_indicator_get_active_wired_name (NetworkIndicator* self);
static gchar* network_indicator_get_active_wifi_name (NetworkIndicator* self);
static void network_indicator_finalize (GObject * obj);
static GType network_indicator_get_type_once (void);
static void _vala_network_indicator_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_network_indicator_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
network_indicator_get_instance_private (NetworkIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkIndicator_private_offset);
}

static void
_network_indicator_on_state_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 41 "../src/Indicator.vala"
	network_indicator_on_state_changed ((NetworkIndicator*) self);
#line 124 "Indicator.c"
}

static void
__lambda35_ (NetworkIndicator* self)
{
#line 44 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 132 "Indicator.c"
}

static void
___lambda35__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                            gpointer self)
{
#line 44 "../src/Indicator.vala"
	__lambda35_ ((NetworkIndicator*) self);
#line 141 "Indicator.c"
}

static void
___lambda37_ (NetworkIndicator* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 52 "../src/Indicator.vala"
	g_return_if_fail (res != NULL);
#line 152 "Indicator.c"
	{
#line 54 "../src/Indicator.vala"
		nm_client_dbus_set_property_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_client_get_type (), NMClient), res, &_inner_error0_);
#line 54 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 53 "../src/Indicator.vala"
		e = _inner_error0_;
#line 53 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 56 "../src/Indicator.vala"
		_tmp0_ = e;
#line 56 "../src/Indicator.vala"
		_tmp1_ = _tmp0_->message;
#line 56 "../src/Indicator.vala"
		g_warning ("Indicator.vala:56: Error setting airplane mode: %s", _tmp1_);
#line 53 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 180 "Indicator.c"
	}
	__finally0:
#line 53 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 53 "../src/Indicator.vala"
		return;
#line 191 "Indicator.c"
	}
}

static void
____lambda37__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 49 "../src/Indicator.vala"
	___lambda37_ ((NetworkIndicator*) self, source_object, res);
#line 49 "../src/Indicator.vala"
	g_object_unref (self);
#line 204 "Indicator.c"
}

static gboolean
___lambda36_ (NetworkIndicator* self,
              GdkEventButton* event)
{
	gboolean result;
#line 47 "../src/Indicator.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 48 "../src/Indicator.vala"
	if (event->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 216 "Indicator.c"
		NetworkWidgetsPopoverWidget* _tmp0_;
		NMClient* _tmp1_;
		NMClient* _tmp2_;
		NetworkWidgetsPopoverWidget* _tmp3_;
		NMClient* _tmp4_;
		NMClient* _tmp5_;
		GVariant* _tmp6_;
		GVariant** _tmp7_;
		GVariant** _tmp8_;
		gint _tmp8__length1;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
#line 49 "../src/Indicator.vala"
		_tmp0_ = self->priv->popover_widget;
#line 49 "../src/Indicator.vala"
		_tmp1_ = network_widgets_popover_widget_get_nm_client (_tmp0_);
#line 49 "../src/Indicator.vala"
		_tmp2_ = _tmp1_;
#line 49 "../src/Indicator.vala"
		_tmp3_ = self->priv->popover_widget;
#line 49 "../src/Indicator.vala"
		_tmp4_ = network_widgets_popover_widget_get_nm_client (_tmp3_);
#line 49 "../src/Indicator.vala"
		_tmp5_ = _tmp4_;
#line 49 "../src/Indicator.vala"
		_tmp6_ = g_variant_new_boolean (!nm_client_networking_get_enabled (_tmp5_));
#line 49 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp6_);
#line 49 "../src/Indicator.vala"
		_tmp7_ = g_new0 (GVariant*, 1 + 1);
#line 49 "../src/Indicator.vala"
		_tmp7_[0] = _tmp6_;
#line 49 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 49 "../src/Indicator.vala"
		_tmp8__length1 = 1;
#line 49 "../src/Indicator.vala"
		_tmp9_ = g_variant_new_tuple (_tmp8_, 1);
#line 49 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp9_);
#line 49 "../src/Indicator.vala"
		_tmp10_ = _tmp9_;
#line 49 "../src/Indicator.vala"
		nm_client_dbus_call (_tmp2_, NM_DBUS_PATH, NM_DBUS_INTERFACE, "Enable", _tmp10_, NULL, -1, NULL, ____lambda37__gasync_ready_callback, g_object_ref (self));
#line 49 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp10_);
#line 49 "../src/Indicator.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 60 "../src/Indicator.vala"
		result = TRUE;
#line 60 "../src/Indicator.vala"
		return result;
#line 269 "Indicator.c"
	}
#line 63 "../src/Indicator.vala"
	result = FALSE;
#line 63 "../src/Indicator.vala"
	return result;
#line 275 "Indicator.c"
}

static gboolean
____lambda36__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda36_ ((NetworkIndicator*) self, event);
#line 47 "../src/Indicator.vala"
	return result;
#line 287 "Indicator.c"
}

NetworkIndicator*
network_indicator_construct (GType object_type,
                             gboolean is_in_session)
{
	NetworkIndicator * self = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	NetworkWidgetsDisplayWidget* _tmp2_;
	NetworkWidgetsPopoverWidget* _tmp3_;
	NetworkWidgetsPopoverWidget* _tmp4_;
	NetworkWidgetsPopoverWidget* _tmp5_;
	NetworkWidgetsPopoverWidget* _tmp6_;
	NetworkWidgetsPopoverWidget* _tmp7_;
#line 28 "../src/Indicator.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 29 "../src/Indicator.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 31 "../src/Indicator.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 31 "../src/Indicator.vala"
	icon_theme = _tmp0_;
#line 32 "../src/Indicator.vala"
	_tmp1_ = icon_theme;
#line 32 "../src/Indicator.vala"
	gtk_icon_theme_add_resource_path (_tmp1_, "/io/elementary/wingpanel/network");
#line 34 "../src/Indicator.vala"
	self = (NetworkIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_NETWORK, "is-in-session", is_in_session, "visible", TRUE, NULL);
#line 38 "../src/Indicator.vala"
	_tmp2_ = network_widgets_display_widget_new ();
#line 38 "../src/Indicator.vala"
	g_object_ref_sink (_tmp2_);
#line 38 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 38 "../src/Indicator.vala"
	self->priv->display_widget = _tmp2_;
#line 40 "../src/Indicator.vala"
	_tmp3_ = network_widgets_popover_widget_new (is_in_session);
#line 40 "../src/Indicator.vala"
	g_object_ref_sink (_tmp3_);
#line 40 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 40 "../src/Indicator.vala"
	self->priv->popover_widget = _tmp3_;
#line 41 "../src/Indicator.vala"
	_tmp4_ = self->priv->popover_widget;
#line 41 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::state", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
#line 42 "../src/Indicator.vala"
	_tmp5_ = self->priv->popover_widget;
#line 42 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::secure", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
#line 43 "../src/Indicator.vala"
	_tmp6_ = self->priv->popover_widget;
#line 43 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::extra-info", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
#line 44 "../src/Indicator.vala"
	_tmp7_ = self->priv->popover_widget;
#line 44 "../src/Indicator.vala"
	g_signal_connect_object (_tmp7_, "settings-shown", (GCallback) ___lambda35__network_widgets_popover_widget_settings_shown, self, 0);
#line 46 "../src/Indicator.vala"
	if (is_in_session) {
#line 352 "Indicator.c"
		NetworkWidgetsDisplayWidget* _tmp8_;
#line 47 "../src/Indicator.vala"
		_tmp8_ = self->priv->display_widget;
#line 47 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp8_, "button-press-event", (GCallback) ____lambda36__gtk_widget_button_press_event, self, 0);
#line 358 "Indicator.c"
	}
#line 67 "../src/Indicator.vala"
	network_indicator_update_tooltip (self);
#line 68 "../src/Indicator.vala"
	network_indicator_on_state_changed (self);
#line 69 "../src/Indicator.vala"
	network_indicator_start_monitor (self);
#line 27 "../src/Indicator.vala"
	return self;
#line 368 "Indicator.c"
}

NetworkIndicator*
network_indicator_new (gboolean is_in_session)
{
#line 27 "../src/Indicator.vala"
	return network_indicator_construct (NETWORK_TYPE_INDICATOR, is_in_session);
#line 376 "Indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 384 "Indicator.c"
}

static GtkWidget*
network_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsDisplayWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 72 "../src/Indicator.vala"
	self = (NetworkIndicator*) base;
#line 73 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 73 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 73 "../src/Indicator.vala"
	result = _tmp1_;
#line 73 "../src/Indicator.vala"
	return result;
#line 404 "Indicator.c"
}

static GtkWidget*
network_indicator_real_get_widget (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 76 "../src/Indicator.vala"
	self = (NetworkIndicator*) base;
#line 77 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 77 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 77 "../src/Indicator.vala"
	result = _tmp1_;
#line 77 "../src/Indicator.vala"
	return result;
#line 424 "Indicator.c"
}

static void
network_indicator_on_state_changed (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	NetworkWidgetsDisplayWidget* _tmp1_;
	NetworkWidgetsDisplayWidget* _tmp2_;
	NetworkWidgetsPopoverWidget* _tmp3_;
	NetworkState _tmp4_;
	NetworkState _tmp5_;
	NetworkWidgetsPopoverWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	NetworkWidgetsPopoverWidget* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 80 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 81 "../src/Indicator.vala"
	_vala_assert (_tmp0_ != NULL, "popover_widget != null");
#line 82 "../src/Indicator.vala"
	_tmp1_ = self->priv->display_widget;
#line 82 "../src/Indicator.vala"
	_vala_assert (_tmp1_ != NULL, "display_widget != null");
#line 84 "../src/Indicator.vala"
	_tmp2_ = self->priv->display_widget;
#line 84 "../src/Indicator.vala"
	_tmp3_ = self->priv->popover_widget;
#line 84 "../src/Indicator.vala"
	_tmp4_ = network_widgets_popover_widget_get_state (_tmp3_);
#line 84 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 84 "../src/Indicator.vala"
	_tmp6_ = self->priv->popover_widget;
#line 84 "../src/Indicator.vala"
	_tmp7_ = network_widgets_popover_widget_get_secure (_tmp6_);
#line 84 "../src/Indicator.vala"
	_tmp8_ = _tmp7_;
#line 84 "../src/Indicator.vala"
	_tmp9_ = self->priv->popover_widget;
#line 84 "../src/Indicator.vala"
	_tmp10_ = network_widgets_popover_widget_get_extra_info (_tmp9_);
#line 84 "../src/Indicator.vala"
	_tmp11_ = _tmp10_;
#line 84 "../src/Indicator.vala"
	network_widgets_display_widget_update_state (_tmp2_, _tmp5_, _tmp8_, _tmp11_);
#line 86 "../src/Indicator.vala"
	network_indicator_update_tooltip (self);
#line 476 "Indicator.c"
}

static void
__lambda38_ (NetworkIndicator* self,
             gboolean availabe)
{
	gboolean _tmp0_;
	GNetworkMonitor* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 93 "../src/Indicator.vala"
	_tmp0_ = self->priv->_is_in_session;
#line 93 "../src/Indicator.vala"
	if (!_tmp0_) {
#line 94 "../src/Indicator.vala"
		return;
#line 492 "Indicator.c"
	}
#line 97 "../src/Indicator.vala"
	_tmp1_ = self->priv->network_monitor;
#line 97 "../src/Indicator.vala"
	if (g_network_monitor_get_connectivity (_tmp1_) == G_NETWORK_CONNECTIVITY_PORTAL) {
#line 498 "Indicator.c"
		{
			GDesktopAppInfo* appinfo = NULL;
			GDesktopAppInfo* _tmp2_;
			GDesktopAppInfo* _tmp3_;
#line 99 "../src/Indicator.vala"
			_tmp2_ = g_desktop_app_info_new ("io.elementary.capnet-assist.desktop");
#line 99 "../src/Indicator.vala"
			appinfo = _tmp2_;
#line 100 "../src/Indicator.vala"
			_tmp3_ = appinfo;
#line 100 "../src/Indicator.vala"
			g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 100 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/Indicator.vala"
				_g_object_unref0 (appinfo);
#line 515 "Indicator.c"
				goto __catch0_g_error;
			}
#line 98 "../src/Indicator.vala"
			_g_object_unref0 (appinfo);
#line 520 "Indicator.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 98 "../src/Indicator.vala"
			e = _inner_error0_;
#line 98 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 102 "../src/Indicator.vala"
			_tmp4_ = e;
#line 102 "../src/Indicator.vala"
			_tmp5_ = _tmp4_->message;
#line 102 "../src/Indicator.vala"
			g_warning ("Indicator.vala:102: %s", _tmp5_);
#line 98 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 540 "Indicator.c"
		}
		__finally0:
#line 98 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 98 "../src/Indicator.vala"
			return;
#line 551 "Indicator.c"
		}
	}
#line 106 "../src/Indicator.vala"
	network_indicator_update_tooltip (self);
#line 556 "Indicator.c"
}

static void
___lambda38__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                gboolean network_available,
                                                gpointer self)
{
#line 92 "../src/Indicator.vala"
	__lambda38_ ((NetworkIndicator*) self, network_available);
#line 566 "Indicator.c"
}

static void
network_indicator_start_monitor (NetworkIndicator* self)
{
	GNetworkMonitor* _tmp0_;
	GNetworkMonitor* _tmp1_;
	GNetworkMonitor* _tmp2_;
#line 89 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Indicator.vala"
	_tmp0_ = g_network_monitor_get_default ();
#line 90 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 90 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->network_monitor);
#line 90 "../src/Indicator.vala"
	self->priv->network_monitor = _tmp1_;
#line 92 "../src/Indicator.vala"
	_tmp2_ = self->priv->network_monitor;
#line 92 "../src/Indicator.vala"
	g_signal_connect_object (_tmp2_, "network-changed", (GCallback) ___lambda38__g_network_monitor_network_changed, self, 0);
#line 589 "Indicator.c"
}

static void
network_indicator_real_opened (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
#line 110 "../src/Indicator.vala"
	self = (NetworkIndicator*) base;
#line 111 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 111 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 603 "Indicator.c"
		NetworkWidgetsPopoverWidget* _tmp1_;
#line 112 "../src/Indicator.vala"
		_tmp1_ = self->priv->popover_widget;
#line 112 "../src/Indicator.vala"
		network_widgets_popover_widget_opened (_tmp1_);
#line 609 "Indicator.c"
	}
}

static void
network_indicator_real_closed (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
#line 116 "../src/Indicator.vala"
	self = (NetworkIndicator*) base;
#line 117 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 117 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 624 "Indicator.c"
		NetworkWidgetsPopoverWidget* _tmp1_;
#line 118 "../src/Indicator.vala"
		_tmp1_ = self->priv->popover_widget;
#line 118 "../src/Indicator.vala"
		network_widgets_popover_widget_closed (_tmp1_);
#line 630 "Indicator.c"
	}
}

static void
network_indicator_update_tooltip (NetworkIndicator* self)
{
	gchar* tooltip_markup = NULL;
	gchar* _tmp0_;
	NetworkWidgetsPopoverWidget* _tmp1_;
	NetworkState _tmp2_;
	NetworkState _tmp3_;
	gboolean _tmp23_;
#line 122 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/Indicator.vala"
	_tmp0_ = g_strdup ("");
#line 123 "../src/Indicator.vala"
	tooltip_markup = _tmp0_;
#line 124 "../src/Indicator.vala"
	_tmp1_ = self->priv->popover_widget;
#line 124 "../src/Indicator.vala"
	_tmp2_ = network_widgets_popover_widget_get_state (_tmp1_);
#line 124 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 124 "../src/Indicator.vala"
	switch (_tmp3_) {
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTING_WIRED:
#line 659 "Indicator.c"
		{
			gchar* active_wired_name = NULL;
			gchar* _tmp4_;
			const gchar* _tmp5_;
#line 132 "../src/Indicator.vala"
			_tmp4_ = network_indicator_get_active_wired_name (self);
#line 132 "../src/Indicator.vala"
			active_wired_name = _tmp4_;
#line 134 "../src/Indicator.vala"
			_tmp5_ = active_wired_name;
#line 134 "../src/Indicator.vala"
			if (g_strcmp0 (_tmp5_, _ ("Wired")) == 0) {
#line 672 "Indicator.c"
				gchar* _tmp6_;
#line 135 "../src/Indicator.vala"
				_tmp6_ = g_strdup (_ ("Connecting to wired network"));
#line 135 "../src/Indicator.vala"
				_g_free0 (tooltip_markup);
#line 135 "../src/Indicator.vala"
				tooltip_markup = _tmp6_;
#line 680 "Indicator.c"
			} else {
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 137 "../src/Indicator.vala"
				_tmp7_ = active_wired_name;
#line 137 "../src/Indicator.vala"
				_tmp8_ = g_strdup_printf (_ ("Connecting to “%s”"), _tmp7_);
#line 137 "../src/Indicator.vala"
				_g_free0 (tooltip_markup);
#line 137 "../src/Indicator.vala"
				tooltip_markup = _tmp8_;
#line 692 "Indicator.c"
			}
#line 139 "../src/Indicator.vala"
			_g_free0 (active_wired_name);
#line 139 "../src/Indicator.vala"
			break;
#line 698 "Indicator.c"
		}
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTING_WIFI:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTING_MOBILE:
#line 704 "Indicator.c"
		{
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 142 "../src/Indicator.vala"
			_tmp9_ = network_indicator_get_active_wifi_name (self);
#line 142 "../src/Indicator.vala"
			_tmp10_ = _tmp9_;
#line 142 "../src/Indicator.vala"
			_tmp11_ = g_strdup_printf (_ ("Connecting to “%s”"), _tmp10_);
#line 142 "../src/Indicator.vala"
			_g_free0 (tooltip_markup);
#line 142 "../src/Indicator.vala"
			tooltip_markup = _tmp11_;
#line 142 "../src/Indicator.vala"
			_g_free0 (_tmp10_);
#line 143 "../src/Indicator.vala"
			break;
#line 723 "Indicator.c"
		}
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_WIRED:
#line 727 "Indicator.c"
		{
			gchar* active_wired_name = NULL;
			gchar* _tmp12_;
			const gchar* _tmp13_;
#line 145 "../src/Indicator.vala"
			_tmp12_ = network_indicator_get_active_wired_name (self);
#line 145 "../src/Indicator.vala"
			active_wired_name = _tmp12_;
#line 147 "../src/Indicator.vala"
			_tmp13_ = active_wired_name;
#line 147 "../src/Indicator.vala"
			if (g_strcmp0 (_tmp13_, _ ("Wired")) == 0) {
#line 740 "Indicator.c"
				gchar* _tmp14_;
#line 148 "../src/Indicator.vala"
				_tmp14_ = g_strdup (_ ("Connected to wired network"));
#line 148 "../src/Indicator.vala"
				_g_free0 (tooltip_markup);
#line 148 "../src/Indicator.vala"
				tooltip_markup = _tmp14_;
#line 748 "Indicator.c"
			} else {
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 150 "../src/Indicator.vala"
				_tmp15_ = active_wired_name;
#line 150 "../src/Indicator.vala"
				_tmp16_ = g_strdup_printf (_ ("Connected to “%s”"), _tmp15_);
#line 150 "../src/Indicator.vala"
				_g_free0 (tooltip_markup);
#line 150 "../src/Indicator.vala"
				tooltip_markup = _tmp16_;
#line 760 "Indicator.c"
			}
#line 152 "../src/Indicator.vala"
			_g_free0 (active_wired_name);
#line 152 "../src/Indicator.vala"
			break;
#line 766 "Indicator.c"
		}
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_WIFI_WEAK:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_WIFI_OK:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_WIFI_GOOD:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_WIFI_EXCELLENT:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_MOBILE_WEAK:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_MOBILE_OK:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_MOBILE_GOOD:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_CONNECTED_MOBILE_EXCELLENT:
#line 784 "Indicator.c"
		{
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 161 "../src/Indicator.vala"
			_tmp17_ = network_indicator_get_active_wifi_name (self);
#line 161 "../src/Indicator.vala"
			_tmp18_ = _tmp17_;
#line 161 "../src/Indicator.vala"
			_tmp19_ = g_strdup_printf (_ ("Connected to “%s”"), _tmp18_);
#line 161 "../src/Indicator.vala"
			_g_free0 (tooltip_markup);
#line 161 "../src/Indicator.vala"
			tooltip_markup = _tmp19_;
#line 161 "../src/Indicator.vala"
			_g_free0 (_tmp18_);
#line 162 "../src/Indicator.vala"
			break;
#line 803 "Indicator.c"
		}
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_FAILED:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_FAILED_WIFI:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_FAILED_MOBILE:
#line 811 "Indicator.c"
		{
			gchar* _tmp20_;
#line 166 "../src/Indicator.vala"
			_tmp20_ = g_strdup (_ ("Failed to connect"));
#line 166 "../src/Indicator.vala"
			_g_free0 (tooltip_markup);
#line 166 "../src/Indicator.vala"
			tooltip_markup = _tmp20_;
#line 167 "../src/Indicator.vala"
			break;
#line 822 "Indicator.c"
		}
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_DISCONNECTED:
#line 124 "../src/Indicator.vala"
		case NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE:
#line 828 "Indicator.c"
		{
			gchar* _tmp21_;
#line 170 "../src/Indicator.vala"
			_tmp21_ = g_strdup (_ ("Disconnected"));
#line 170 "../src/Indicator.vala"
			_g_free0 (tooltip_markup);
#line 170 "../src/Indicator.vala"
			tooltip_markup = _tmp21_;
#line 171 "../src/Indicator.vala"
			break;
#line 839 "Indicator.c"
		}
		default:
		{
			gchar* _tmp22_;
#line 173 "../src/Indicator.vala"
			_tmp22_ = g_strdup (_ ("Not connected"));
#line 173 "../src/Indicator.vala"
			_g_free0 (tooltip_markup);
#line 173 "../src/Indicator.vala"
			tooltip_markup = _tmp22_;
#line 174 "../src/Indicator.vala"
			break;
#line 852 "Indicator.c"
		}
	}
#line 177 "../src/Indicator.vala"
	_tmp23_ = self->priv->_is_in_session;
#line 177 "../src/Indicator.vala"
	if (_tmp23_) {
#line 859 "Indicator.c"
		const gchar* _tmp24_ = NULL;
		NetworkWidgetsPopoverWidget* _tmp25_;
		NetworkState _tmp26_;
		NetworkState _tmp27_;
		gchar* middle_click_markup = NULL;
		gchar* _tmp28_;
		NetworkWidgetsDisplayWidget* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 178 "../src/Indicator.vala"
		_tmp25_ = self->priv->popover_widget;
#line 178 "../src/Indicator.vala"
		_tmp26_ = network_widgets_popover_widget_get_state (_tmp25_);
#line 178 "../src/Indicator.vala"
		_tmp27_ = _tmp26_;
#line 178 "../src/Indicator.vala"
		if (_tmp27_ == NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE) {
#line 179 "../src/Indicator.vala"
			_tmp24_ = _ ("Middle-click to turn airplane mode off");
#line 883 "Indicator.c"
		} else {
#line 180 "../src/Indicator.vala"
			_tmp24_ = _ ("Middle-click to turn airplane mode on");
#line 887 "Indicator.c"
		}
#line 178 "../src/Indicator.vala"
		_tmp28_ = g_strdup (_tmp24_);
#line 178 "../src/Indicator.vala"
		middle_click_markup = _tmp28_;
#line 182 "../src/Indicator.vala"
		_tmp29_ = self->priv->display_widget;
#line 182 "../src/Indicator.vala"
		_tmp30_ = tooltip_markup;
#line 182 "../src/Indicator.vala"
		_tmp31_ = middle_click_markup;
#line 182 "../src/Indicator.vala"
		_tmp32_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp31_);
#line 182 "../src/Indicator.vala"
		_tmp33_ = _tmp32_;
#line 182 "../src/Indicator.vala"
		_tmp34_ = g_strdup_printf ("%s\n%s", _tmp30_, _tmp33_);
#line 182 "../src/Indicator.vala"
		_tmp35_ = _tmp34_;
#line 182 "../src/Indicator.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp29_, _tmp35_);
#line 182 "../src/Indicator.vala"
		_g_free0 (_tmp35_);
#line 182 "../src/Indicator.vala"
		_g_free0 (_tmp33_);
#line 177 "../src/Indicator.vala"
		_g_free0 (middle_click_markup);
#line 915 "Indicator.c"
	} else {
		NetworkWidgetsDisplayWidget* _tmp36_;
		const gchar* _tmp37_;
#line 187 "../src/Indicator.vala"
		_tmp36_ = self->priv->display_widget;
#line 187 "../src/Indicator.vala"
		_tmp37_ = tooltip_markup;
#line 187 "../src/Indicator.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp36_, _tmp37_);
#line 925 "Indicator.c"
	}
#line 122 "../src/Indicator.vala"
	_g_free0 (tooltip_markup);
#line 929 "Indicator.c"
}

static gchar*
network_indicator_get_active_wired_name (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gchar* _tmp11_;
	gchar* result;
#line 191 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 192 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 192 "../src/Indicator.vala"
	_tmp1_ = network_widgets_popover_widget_get_network_interface (_tmp0_);
#line 192 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 948 "Indicator.c"
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
#line 192 "../src/Indicator.vala"
		iface_collection = _tmp2_;
#line 192 "../src/Indicator.vala"
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
#line 956 "Indicator.c"
			NetworkWidgetNMInterface* iface = NULL;
#line 192 "../src/Indicator.vala"
			iface = (NetworkWidgetNMInterface*) iface_it->data;
#line 960 "Indicator.c"
			{
				NetworkWidgetNMInterface* _tmp3_;
#line 193 "../src/Indicator.vala"
				_tmp3_ = iface;
#line 193 "../src/Indicator.vala"
				if (NETWORK_IS_ETHER_INTERFACE (_tmp3_)) {
#line 967 "Indicator.c"
					gchar* active_wired_name = NULL;
					NetworkWidgetNMInterface* _tmp4_;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					const gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 194 "../src/Indicator.vala"
					_tmp4_ = iface;
#line 194 "../src/Indicator.vala"
					_tmp5_ = network_widget_nm_interface_get_display_title (_tmp4_);
#line 194 "../src/Indicator.vala"
					_tmp6_ = _tmp5_;
#line 194 "../src/Indicator.vala"
					_tmp7_ = g_strdup (_tmp6_);
#line 194 "../src/Indicator.vala"
					active_wired_name = _tmp7_;
#line 195 "../src/Indicator.vala"
					_tmp8_ = active_wired_name;
#line 195 "../src/Indicator.vala"
					_tmp9_ = g_strdup_printf ("Active network (Wired): %s", _tmp8_);
#line 195 "../src/Indicator.vala"
					_tmp10_ = _tmp9_;
#line 195 "../src/Indicator.vala"
					g_debug ("Indicator.vala:195: %s", _tmp10_);
#line 195 "../src/Indicator.vala"
					_g_free0 (_tmp10_);
#line 196 "../src/Indicator.vala"
					result = active_wired_name;
#line 196 "../src/Indicator.vala"
					return result;
#line 1000 "Indicator.c"
				}
			}
		}
	}
#line 200 "../src/Indicator.vala"
	_tmp11_ = g_strdup (_ ("unknown network"));
#line 200 "../src/Indicator.vala"
	result = _tmp11_;
#line 200 "../src/Indicator.vala"
	return result;
#line 1011 "Indicator.c"
}

static gchar*
network_indicator_get_active_wifi_name (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gchar* _tmp11_;
	gchar* result;
#line 203 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 204 "../src/Indicator.vala"
	_tmp1_ = network_widgets_popover_widget_get_network_interface (_tmp0_);
#line 204 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 1030 "Indicator.c"
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
#line 204 "../src/Indicator.vala"
		iface_collection = _tmp2_;
#line 204 "../src/Indicator.vala"
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
#line 1038 "Indicator.c"
			NetworkWidgetNMInterface* iface = NULL;
#line 204 "../src/Indicator.vala"
			iface = (NetworkWidgetNMInterface*) iface_it->data;
#line 1042 "Indicator.c"
			{
				NetworkWidgetNMInterface* _tmp3_;
#line 205 "../src/Indicator.vala"
				_tmp3_ = iface;
#line 205 "../src/Indicator.vala"
				if (NETWORK_IS_WIFI_INTERFACE (_tmp3_)) {
#line 1049 "Indicator.c"
					gchar* active_wifi_name = NULL;
					NetworkWidgetNMInterface* _tmp4_;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					const gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 206 "../src/Indicator.vala"
					_tmp4_ = iface;
#line 206 "../src/Indicator.vala"
					_tmp5_ = network_wifi_interface_get_active_ap_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface));
#line 206 "../src/Indicator.vala"
					_tmp6_ = _tmp5_;
#line 206 "../src/Indicator.vala"
					_tmp7_ = g_strdup (_tmp6_);
#line 206 "../src/Indicator.vala"
					active_wifi_name = _tmp7_;
#line 207 "../src/Indicator.vala"
					_tmp8_ = active_wifi_name;
#line 207 "../src/Indicator.vala"
					_tmp9_ = g_strdup_printf ("Active network (WiFi): %s", _tmp8_);
#line 207 "../src/Indicator.vala"
					_tmp10_ = _tmp9_;
#line 207 "../src/Indicator.vala"
					g_debug ("Indicator.vala:207: %s", _tmp10_);
#line 207 "../src/Indicator.vala"
					_g_free0 (_tmp10_);
#line 208 "../src/Indicator.vala"
					result = active_wifi_name;
#line 208 "../src/Indicator.vala"
					return result;
#line 1082 "Indicator.c"
				}
			}
		}
	}
#line 212 "../src/Indicator.vala"
	_tmp11_ = g_strdup (_ ("unknown network"));
#line 212 "../src/Indicator.vala"
	result = _tmp11_;
#line 212 "../src/Indicator.vala"
	return result;
#line 1093 "Indicator.c"
}

gboolean
network_indicator_get_is_in_session (NetworkIndicator* self)
{
	gboolean result;
#line 25 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/Indicator.vala"
	result = self->priv->_is_in_session;
#line 25 "../src/Indicator.vala"
	return result;
#line 1106 "Indicator.c"
}

void
network_indicator_set_is_in_session (NetworkIndicator* self,
                                     gboolean value)
{
	gboolean old_value;
#line 25 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Indicator.vala"
	old_value = network_indicator_get_is_in_session (self);
#line 25 "../src/Indicator.vala"
	if (old_value != value) {
#line 25 "../src/Indicator.vala"
		self->priv->_is_in_session = value;
#line 25 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, network_indicator_properties[NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY]);
#line 1124 "Indicator.c"
	}
}

static void
network_indicator_class_init (NetworkIndicatorClass * klass,
                              gpointer klass_data)
{
#line 19 "../src/Indicator.vala"
	network_indicator_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &NetworkIndicator_private_offset);
#line 19 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) network_indicator_real_get_display_widget;
#line 19 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) network_indicator_real_get_widget;
#line 19 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) network_indicator_real_opened;
#line 19 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) network_indicator_real_closed;
#line 19 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_indicator_get_property;
#line 19 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_indicator_set_property;
#line 19 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = network_indicator_finalize;
#line 19 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY, network_indicator_properties[NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1152 "Indicator.c"
}

static void
network_indicator_instance_init (NetworkIndicator * self,
                                 gpointer klass)
{
#line 19 "../src/Indicator.vala"
	self->priv = network_indicator_get_instance_private (self);
#line 20 "../src/Indicator.vala"
	self->priv->display_widget = NULL;
#line 21 "../src/Indicator.vala"
	self->priv->popover_widget = NULL;
#line 25 "../src/Indicator.vala"
	self->priv->_is_in_session = FALSE;
#line 1167 "Indicator.c"
}

static void
network_indicator_finalize (GObject * obj)
{
	NetworkIndicator * self;
#line 19 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_INDICATOR, NetworkIndicator);
#line 20 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 21 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 23 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->network_monitor);
#line 19 "../src/Indicator.vala"
	G_OBJECT_CLASS (network_indicator_parent_class)->finalize (obj);
#line 1184 "Indicator.c"
}

static GType
network_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkIndicator), 0, (GInstanceInitFunc) network_indicator_instance_init, NULL };
	GType network_indicator_type_id;
	network_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "NetworkIndicator", &g_define_type_info, 0);
	NetworkIndicator_private_offset = g_type_add_instance_private (network_indicator_type_id, sizeof (NetworkIndicatorPrivate));
	return network_indicator_type_id;
}

GType
network_indicator_get_type (void)
{
	static volatile gsize network_indicator_type_id__once = 0;
	if (g_once_init_enter (&network_indicator_type_id__once)) {
		GType network_indicator_type_id;
		network_indicator_type_id = network_indicator_get_type_once ();
		g_once_init_leave (&network_indicator_type_id__once, network_indicator_type_id);
	}
	return network_indicator_type_id__once;
}

static void
_vala_network_indicator_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NetworkIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_INDICATOR, NetworkIndicator);
#line 19 "../src/Indicator.vala"
	switch (property_id) {
#line 19 "../src/Indicator.vala"
		case NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 19 "../src/Indicator.vala"
		g_value_set_boolean (value, network_indicator_get_is_in_session (self));
#line 19 "../src/Indicator.vala"
		break;
#line 1225 "Indicator.c"
		default:
#line 19 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Indicator.vala"
		break;
#line 1231 "Indicator.c"
	}
}

static void
_vala_network_indicator_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NetworkIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_INDICATOR, NetworkIndicator);
#line 19 "../src/Indicator.vala"
	switch (property_id) {
#line 19 "../src/Indicator.vala"
		case NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 19 "../src/Indicator.vala"
		network_indicator_set_is_in_session (self, g_value_get_boolean (value));
#line 19 "../src/Indicator.vala"
		break;
#line 1251 "Indicator.c"
		default:
#line 19 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Indicator.vala"
		break;
#line 1257 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	NetworkIndicator* indicator = NULL;
	NetworkIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 216 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 217 "../src/Indicator.vala"
	g_debug ("Indicator.vala:217: Activating Network Indicator");
#line 218 "../src/Indicator.vala"
	_tmp0_ = network_indicator_new (server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION);
#line 218 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 219 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 219 "../src/Indicator.vala"
	return result;
#line 1280 "Indicator.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

