/* VpnInterface.c generated by valac 0.56.14, the Vala compiler
 * generated from VpnInterface.vala, do not modify */

/*
* SPDX-License-Identifier: LGPL-2.1-or-later
* SPDX-FileCopyrightText: 2017-2023 elementary, Inc. (https://elementary.io)
*/

#include "network.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	NETWORK_VPN_INTERFACE_0_PROPERTY,
	NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY,
	NETWORK_VPN_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NetworkVpnInterfacePrivate {
	NMClient* _nm_client;
	GtkFlowBox* vpn_list;
};

struct _Block5Data {
	int _ref_count_;
	NetworkVpnInterface* self;
	NetworkVpnMenuItem* item;
};

static gint NetworkVpnInterface_private_offset;
static gpointer network_vpn_interface_parent_class = NULL;

static void network_vpn_interface_check_vpn_availability (NetworkVpnInterface* self);
static void network_vpn_interface_show_vpn (NetworkVpnInterface* self,
                                     gboolean show);
static void network_vpn_interface_active_connected_added_cb (NetworkVpnInterface* self,
                                                      NMActiveConnection* active_connection);
static NetworkVpnMenuItem* network_vpn_interface_get_item_for_active_connection (NetworkVpnInterface* self,
                                                                          NMActiveConnection* active_connection);
static void network_vpn_interface_active_connected_removed_cb (NetworkVpnInterface* self,
                                                        NMActiveConnection* active_connection);
static void network_vpn_interface_vpn_activate_cb (NetworkVpnInterface* self,
                                            NetworkVpnMenuItem* item);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda22_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda22__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void ___lambda23_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda23__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void network_vpn_interface_vpn_added_cb (NetworkVpnInterface* self,
                                         GObject* obj);
static void network_vpn_interface_vpn_removed_cb (NetworkVpnInterface* self,
                                           NMRemoteConnection* connection);
static GObject * network_vpn_interface_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _network_vpn_interface___lambda24_ (NetworkVpnInterface* self,
                                         NMRemoteConnection* connection);
static void __network_vpn_interface___lambda24__gfunc (gconstpointer data,
                                                gpointer self);
static void _network_vpn_interface___lambda25_ (NetworkVpnInterface* self,
                                         NMActiveConnection* connection);
static void __network_vpn_interface___lambda25__gfunc (gconstpointer data,
                                                gpointer self);
static void _network_vpn_interface_check_vpn_availability_gtk_container_add (GtkContainer* _sender,
                                                                      GtkWidget* widget,
                                                                      gpointer self);
static void _network_vpn_interface_check_vpn_availability_gtk_container_remove (GtkContainer* _sender,
                                                                         GtkWidget* widget,
                                                                         gpointer self);
static void _network_vpn_interface_vpn_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                     NMRemoteConnection* connection,
                                                                     gpointer self);
static void _network_vpn_interface_vpn_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                         NMRemoteConnection* connection,
                                                                         gpointer self);
static void _network_vpn_interface_active_connected_added_cb_nm_client_active_connection_added (NMClient* _sender,
                                                                                         NMActiveConnection* active_connection,
                                                                                         gpointer self);
static void _network_vpn_interface_active_connected_removed_cb_nm_client_active_connection_removed (NMClient* _sender,
                                                                                             NMActiveConnection* active_connection,
                                                                                             gpointer self);
static void _network_vpn_interface___lambda26_ (NetworkVpnInterface* self,
                                         GtkFlowBoxChild* child);
static void __network_vpn_interface___lambda26__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                                       GtkFlowBoxChild* child,
                                                                       gpointer self);
static void network_vpn_interface_finalize (GObject * obj);
static GType network_vpn_interface_get_type_once (void);
static void _vala_network_vpn_interface_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_interface_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_interface_get_instance_private (NetworkVpnInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVpnInterface_private_offset);
}

NetworkVpnInterface*
network_vpn_interface_construct (GType object_type,
                                 NMClient* nm_client)
{
	NetworkVpnInterface * self = NULL;
#line 11 "../src/Widgets/VpnInterface.vala"
	g_return_val_if_fail (nm_client != NULL, NULL);
#line 12 "../src/Widgets/VpnInterface.vala"
	self = (NetworkVpnInterface*) g_object_new (object_type, "nm-client", nm_client, NULL);
#line 11 "../src/Widgets/VpnInterface.vala"
	return self;
#line 134 "VpnInterface.c"
}

NetworkVpnInterface*
network_vpn_interface_new (NMClient* nm_client)
{
#line 11 "../src/Widgets/VpnInterface.vala"
	return network_vpn_interface_construct (NETWORK_TYPE_VPN_INTERFACE, nm_client);
#line 142 "VpnInterface.c"
}

static void
network_vpn_interface_check_vpn_availability (NetworkVpnInterface* self)
{
	GtkFlowBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 49 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = self->priv->vpn_list;
#line 50 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 50 "../src/Widgets/VpnInterface.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_show_vpn (self, g_list_length (_tmp2_) > ((guint) 0));
#line 50 "../src/Widgets/VpnInterface.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 163 "VpnInterface.c"
}

static void
network_vpn_interface_show_vpn (NetworkVpnInterface* self,
                                gboolean show)
{
	GtkSeparator* _tmp0_;
	GtkSeparator* _tmp1_;
	GtkSeparator* _tmp2_;
	GtkSeparator* _tmp3_;
#line 53 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = network_widget_nm_interface_get_sep ((NetworkWidgetNMInterface*) self);
#line 54 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = _tmp0_;
#line 54 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp1_, !show);
#line 54 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) self, !show);
#line 55 "../src/Widgets/VpnInterface.vala"
	_tmp2_ = network_widget_nm_interface_get_sep ((NetworkWidgetNMInterface*) self);
#line 55 "../src/Widgets/VpnInterface.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, show);
#line 55 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_visible ((GtkWidget*) self, show);
#line 192 "VpnInterface.c"
}

static void
network_vpn_interface_active_connected_added_cb (NetworkVpnInterface* self,
                                                 NMActiveConnection* active_connection)
{
	const gchar* connection_type = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	NetworkVpnMenuItem* menu_item = NULL;
	NetworkVpnMenuItem* _tmp4_;
	NetworkVpnMenuItem* _tmp5_;
#line 58 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (active_connection != NULL);
#line 59 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = nm_active_connection_get_connection_type (active_connection);
#line 59 "../src/Widgets/VpnInterface.vala"
	connection_type = _tmp0_;
#line 60 "../src/Widgets/VpnInterface.vala"
	_tmp2_ = connection_type;
#line 60 "../src/Widgets/VpnInterface.vala"
	if (g_strcmp0 (_tmp2_, NM_SETTING_VPN_SETTING_NAME) != 0) {
#line 218 "VpnInterface.c"
		const gchar* _tmp3_;
#line 60 "../src/Widgets/VpnInterface.vala"
		_tmp3_ = connection_type;
#line 60 "../src/Widgets/VpnInterface.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, NM_SETTING_WIREGUARD_SETTING_NAME) != 0;
#line 224 "VpnInterface.c"
	} else {
#line 60 "../src/Widgets/VpnInterface.vala"
		_tmp1_ = FALSE;
#line 228 "VpnInterface.c"
	}
#line 60 "../src/Widgets/VpnInterface.vala"
	if (_tmp1_) {
#line 61 "../src/Widgets/VpnInterface.vala"
		return;
#line 234 "VpnInterface.c"
	}
#line 64 "../src/Widgets/VpnInterface.vala"
	_tmp4_ = network_vpn_interface_get_item_for_active_connection (self, active_connection);
#line 64 "../src/Widgets/VpnInterface.vala"
	menu_item = _tmp4_;
#line 65 "../src/Widgets/VpnInterface.vala"
	_tmp5_ = menu_item;
#line 65 "../src/Widgets/VpnInterface.vala"
	if (_tmp5_ != NULL) {
#line 244 "VpnInterface.c"
		NetworkVpnMenuItem* _tmp6_;
#line 66 "../src/Widgets/VpnInterface.vala"
		_tmp6_ = menu_item;
#line 66 "../src/Widgets/VpnInterface.vala"
		network_vpn_menu_item_set_vpn_connection (_tmp6_, active_connection);
#line 250 "VpnInterface.c"
	}
#line 58 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (menu_item);
#line 254 "VpnInterface.c"
}

static void
network_vpn_interface_active_connected_removed_cb (NetworkVpnInterface* self,
                                                   NMActiveConnection* active_connection)
{
	NetworkVpnMenuItem* menu_item = NULL;
	NetworkVpnMenuItem* _tmp0_;
	NetworkVpnMenuItem* _tmp1_;
#line 70 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (active_connection != NULL);
#line 71 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = network_vpn_interface_get_item_for_active_connection (self, active_connection);
#line 71 "../src/Widgets/VpnInterface.vala"
	menu_item = _tmp0_;
#line 72 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = menu_item;
#line 72 "../src/Widgets/VpnInterface.vala"
	if (_tmp1_ != NULL) {
#line 276 "VpnInterface.c"
		NetworkVpnMenuItem* _tmp2_;
#line 73 "../src/Widgets/VpnInterface.vala"
		_tmp2_ = menu_item;
#line 73 "../src/Widgets/VpnInterface.vala"
		network_vpn_menu_item_set_vpn_connection (_tmp2_, NULL);
#line 282 "VpnInterface.c"
	}
#line 70 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (menu_item);
#line 286 "VpnInterface.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/Widgets/VpnInterface.vala"
	return self ? g_object_ref (self) : NULL;
#line 294 "VpnInterface.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 77 "../src/Widgets/VpnInterface.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 77 "../src/Widgets/VpnInterface.vala"
	return _data5_;
#line 304 "VpnInterface.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 77 "../src/Widgets/VpnInterface.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 314 "VpnInterface.c"
		NetworkVpnInterface* self;
#line 77 "../src/Widgets/VpnInterface.vala"
		self = _data5_->self;
#line 77 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (_data5_->item);
#line 77 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (self);
#line 77 "../src/Widgets/VpnInterface.vala"
		g_slice_free (Block5Data, _data5_);
#line 324 "VpnInterface.c"
	}
}

static void
___lambda22_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	NetworkVpnInterface* self;
	GError* _inner_error0_ = NULL;
#line 85 "../src/Widgets/VpnInterface.vala"
	self = _data5_->self;
#line 85 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (res != NULL);
#line 339 "VpnInterface.c"
	{
#line 87 "../src/Widgets/VpnInterface.vala"
		nm_client_deactivate_connection_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_client_get_type (), NMClient), res, &_inner_error0_);
#line 87 "../src/Widgets/VpnInterface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "VpnInterface.c"
			goto __catch0_g_error;
		}
#line 88 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (_data5_->item->cancellable);
#line 88 "../src/Widgets/VpnInterface.vala"
		_data5_->item->cancellable = NULL;
#line 352 "VpnInterface.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 86 "../src/Widgets/VpnInterface.vala"
		e = _inner_error0_;
#line 86 "../src/Widgets/VpnInterface.vala"
		_inner_error0_ = NULL;
#line 90 "../src/Widgets/VpnInterface.vala"
		_tmp0_ = e;
#line 90 "../src/Widgets/VpnInterface.vala"
		_tmp1_ = _tmp0_->message;
#line 90 "../src/Widgets/VpnInterface.vala"
		g_critical ("VpnInterface.vala:90: Unable to deactivate VPN or Wireguard: %s", _tmp1_);
#line 86 "../src/Widgets/VpnInterface.vala"
		_g_error_free0 (e);
#line 372 "VpnInterface.c"
	}
	__finally0:
#line 86 "../src/Widgets/VpnInterface.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/Widgets/VpnInterface.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/Widgets/VpnInterface.vala"
		g_clear_error (&_inner_error0_);
#line 86 "../src/Widgets/VpnInterface.vala"
		return;
#line 383 "VpnInterface.c"
	}
}

static void
____lambda22__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 85 "../src/Widgets/VpnInterface.vala"
	___lambda22_ (self, source_object, res);
#line 85 "../src/Widgets/VpnInterface.vala"
	block5_data_unref (self);
#line 396 "VpnInterface.c"
}

static void
___lambda23_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	NetworkVpnInterface* self;
	GError* _inner_error0_ = NULL;
#line 94 "../src/Widgets/VpnInterface.vala"
	self = _data5_->self;
#line 94 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (res != NULL);
#line 410 "VpnInterface.c"
	{
		NMActiveConnection* _tmp0_;
		NMActiveConnection* _tmp1_;
#line 96 "../src/Widgets/VpnInterface.vala"
		_tmp0_ = nm_client_activate_connection_finish (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_client_get_type (), NMClient), res, &_inner_error0_);
#line 96 "../src/Widgets/VpnInterface.vala"
		_tmp1_ = _tmp0_;
#line 96 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (_tmp1_);
#line 96 "../src/Widgets/VpnInterface.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "VpnInterface.c"
			goto __catch0_g_error;
		}
#line 97 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (_data5_->item->cancellable);
#line 97 "../src/Widgets/VpnInterface.vala"
		_data5_->item->cancellable = NULL;
#line 429 "VpnInterface.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 95 "../src/Widgets/VpnInterface.vala"
		e = _inner_error0_;
#line 95 "../src/Widgets/VpnInterface.vala"
		_inner_error0_ = NULL;
#line 99 "../src/Widgets/VpnInterface.vala"
		_tmp2_ = e;
#line 99 "../src/Widgets/VpnInterface.vala"
		_tmp3_ = _tmp2_->message;
#line 99 "../src/Widgets/VpnInterface.vala"
		g_critical ("VpnInterface.vala:99: Unable to activate VPN or Wireguard: %s", _tmp3_);
#line 95 "../src/Widgets/VpnInterface.vala"
		_g_error_free0 (e);
#line 449 "VpnInterface.c"
	}
	__finally0:
#line 95 "../src/Widgets/VpnInterface.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../src/Widgets/VpnInterface.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/Widgets/VpnInterface.vala"
		g_clear_error (&_inner_error0_);
#line 95 "../src/Widgets/VpnInterface.vala"
		return;
#line 460 "VpnInterface.c"
	}
}

static void
____lambda23__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 94 "../src/Widgets/VpnInterface.vala"
	___lambda23_ (self, source_object, res);
#line 94 "../src/Widgets/VpnInterface.vala"
	block5_data_unref (self);
#line 473 "VpnInterface.c"
}

static void
network_vpn_interface_vpn_activate_cb (NetworkVpnInterface* self,
                                       NetworkVpnMenuItem* item)
{
	Block5Data* _data5_;
	NetworkVpnMenuItem* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp3_;
	gboolean _tmp4_ = FALSE;
	NMActiveConnection* _tmp5_;
	NMActiveConnection* _tmp6_;
#line 77 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (item != NULL);
#line 77 "../src/Widgets/VpnInterface.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 77 "../src/Widgets/VpnInterface.vala"
	_data5_->_ref_count_ = 1;
#line 77 "../src/Widgets/VpnInterface.vala"
	_data5_->self = g_object_ref (self);
#line 77 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 77 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (_data5_->item);
#line 77 "../src/Widgets/VpnInterface.vala"
	_data5_->item = _tmp0_;
#line 78 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = _data5_->item->cancellable;
#line 78 "../src/Widgets/VpnInterface.vala"
	if (_tmp1_ != NULL) {
#line 507 "VpnInterface.c"
		GCancellable* _tmp2_;
#line 79 "../src/Widgets/VpnInterface.vala"
		_tmp2_ = _data5_->item->cancellable;
#line 79 "../src/Widgets/VpnInterface.vala"
		g_cancellable_cancel (_tmp2_);
#line 513 "VpnInterface.c"
	}
#line 82 "../src/Widgets/VpnInterface.vala"
	_tmp3_ = g_cancellable_new ();
#line 82 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (_data5_->item->cancellable);
#line 82 "../src/Widgets/VpnInterface.vala"
	_data5_->item->cancellable = _tmp3_;
#line 84 "../src/Widgets/VpnInterface.vala"
	_tmp5_ = network_vpn_menu_item_get_vpn_connection (_data5_->item);
#line 84 "../src/Widgets/VpnInterface.vala"
	_tmp6_ = _tmp5_;
#line 84 "../src/Widgets/VpnInterface.vala"
	if (_tmp6_ != NULL) {
#line 527 "VpnInterface.c"
		NMActiveConnection* _tmp7_;
		NMActiveConnection* _tmp8_;
#line 84 "../src/Widgets/VpnInterface.vala"
		_tmp7_ = network_vpn_menu_item_get_vpn_connection (_data5_->item);
#line 84 "../src/Widgets/VpnInterface.vala"
		_tmp8_ = _tmp7_;
#line 84 "../src/Widgets/VpnInterface.vala"
		_tmp4_ = nm_active_connection_get_state (_tmp8_) == NM_ACTIVE_CONNECTION_STATE_ACTIVATED;
#line 536 "VpnInterface.c"
	} else {
#line 84 "../src/Widgets/VpnInterface.vala"
		_tmp4_ = FALSE;
#line 540 "VpnInterface.c"
	}
#line 84 "../src/Widgets/VpnInterface.vala"
	if (_tmp4_) {
#line 544 "VpnInterface.c"
		NMClient* _tmp9_;
		NMActiveConnection* _tmp10_;
		NMActiveConnection* _tmp11_;
		GCancellable* _tmp12_;
#line 85 "../src/Widgets/VpnInterface.vala"
		_tmp9_ = self->priv->_nm_client;
#line 85 "../src/Widgets/VpnInterface.vala"
		_tmp10_ = network_vpn_menu_item_get_vpn_connection (_data5_->item);
#line 85 "../src/Widgets/VpnInterface.vala"
		_tmp11_ = _tmp10_;
#line 85 "../src/Widgets/VpnInterface.vala"
		_tmp12_ = _data5_->item->cancellable;
#line 85 "../src/Widgets/VpnInterface.vala"
		nm_client_deactivate_connection_async (_tmp9_, _tmp11_, _tmp12_, ____lambda22__gasync_ready_callback, block5_data_ref (_data5_));
#line 559 "VpnInterface.c"
	} else {
		NMClient* _tmp13_;
		NMRemoteConnection* _tmp14_;
		NMRemoteConnection* _tmp15_;
		GCancellable* _tmp16_;
#line 94 "../src/Widgets/VpnInterface.vala"
		_tmp13_ = self->priv->_nm_client;
#line 94 "../src/Widgets/VpnInterface.vala"
		_tmp14_ = network_vpn_menu_item_get_remote_connection (_data5_->item);
#line 94 "../src/Widgets/VpnInterface.vala"
		_tmp15_ = _tmp14_;
#line 94 "../src/Widgets/VpnInterface.vala"
		_tmp16_ = _data5_->item->cancellable;
#line 94 "../src/Widgets/VpnInterface.vala"
		nm_client_activate_connection_async (_tmp13_, (NMConnection*) _tmp15_, NULL, NULL, _tmp16_, ____lambda23__gasync_ready_callback, block5_data_ref (_data5_));
#line 575 "VpnInterface.c"
	}
#line 77 "../src/Widgets/VpnInterface.vala"
	block5_data_unref (_data5_);
#line 77 "../src/Widgets/VpnInterface.vala"
	_data5_ = NULL;
#line 581 "VpnInterface.c"
}

static void
network_vpn_interface_vpn_added_cb (NetworkVpnInterface* self,
                                    GObject* obj)
{
	NMRemoteConnection* remote_connection = NULL;
	NMRemoteConnection* _tmp0_;
	const gchar* connection_type = NULL;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 105 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (obj != NULL);
#line 106 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
#line 106 "../src/Widgets/VpnInterface.vala"
	remote_connection = _tmp0_;
#line 107 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = remote_connection;
#line 107 "../src/Widgets/VpnInterface.vala"
	_tmp2_ = nm_connection_get_connection_type ((NMConnection*) _tmp1_);
#line 107 "../src/Widgets/VpnInterface.vala"
	connection_type = _tmp2_;
#line 108 "../src/Widgets/VpnInterface.vala"
	_tmp4_ = connection_type;
#line 108 "../src/Widgets/VpnInterface.vala"
	if (g_strcmp0 (_tmp4_, NM_SETTING_VPN_SETTING_NAME) == 0) {
#line 108 "../src/Widgets/VpnInterface.vala"
		_tmp3_ = TRUE;
#line 615 "VpnInterface.c"
	} else {
		const gchar* _tmp5_;
#line 108 "../src/Widgets/VpnInterface.vala"
		_tmp5_ = connection_type;
#line 108 "../src/Widgets/VpnInterface.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, NM_SETTING_WIREGUARD_SETTING_NAME) == 0;
#line 622 "VpnInterface.c"
	}
#line 108 "../src/Widgets/VpnInterface.vala"
	if (_tmp3_) {
#line 626 "VpnInterface.c"
		NetworkVpnMenuItem* item = NULL;
		NMRemoteConnection* _tmp6_;
		NetworkVpnMenuItem* _tmp7_;
		GtkFlowBox* _tmp8_;
		NetworkVpnMenuItem* _tmp9_;
#line 109 "../src/Widgets/VpnInterface.vala"
		_tmp6_ = remote_connection;
#line 109 "../src/Widgets/VpnInterface.vala"
		_tmp7_ = network_vpn_menu_item_new (_tmp6_);
#line 109 "../src/Widgets/VpnInterface.vala"
		g_object_ref_sink (_tmp7_);
#line 109 "../src/Widgets/VpnInterface.vala"
		item = _tmp7_;
#line 110 "../src/Widgets/VpnInterface.vala"
		_tmp8_ = self->priv->vpn_list;
#line 110 "../src/Widgets/VpnInterface.vala"
		_tmp9_ = item;
#line 110 "../src/Widgets/VpnInterface.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 111 "../src/Widgets/VpnInterface.vala"
		network_vpn_interface_check_vpn_availability (self);
#line 108 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (item);
#line 650 "VpnInterface.c"
	}
#line 105 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (remote_connection);
#line 654 "VpnInterface.c"
}

static void
network_vpn_interface_vpn_removed_cb (NetworkVpnInterface* self,
                                      NMRemoteConnection* connection)
{
	GtkFlowBox* _tmp0_;
	GList* _tmp1_;
#line 115 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (connection != NULL);
#line 116 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = self->priv->vpn_list;
#line 116 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 671 "VpnInterface.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 116 "../src/Widgets/VpnInterface.vala"
		child_collection = _tmp1_;
#line 116 "../src/Widgets/VpnInterface.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 679 "VpnInterface.c"
			GtkWidget* child = NULL;
#line 116 "../src/Widgets/VpnInterface.vala"
			child = (GtkWidget*) child_it->data;
#line 683 "VpnInterface.c"
			{
				NetworkVpnMenuItem* menu_item = NULL;
				GtkWidget* _tmp2_;
				NetworkVpnMenuItem* _tmp3_;
				NMRemoteConnection* _tmp4_;
				NMRemoteConnection* _tmp5_;
#line 117 "../src/Widgets/VpnInterface.vala"
				_tmp2_ = child;
#line 117 "../src/Widgets/VpnInterface.vala"
				menu_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 118 "../src/Widgets/VpnInterface.vala"
				_tmp3_ = menu_item;
#line 118 "../src/Widgets/VpnInterface.vala"
				_tmp4_ = network_vpn_menu_item_get_remote_connection (_tmp3_);
#line 118 "../src/Widgets/VpnInterface.vala"
				_tmp5_ = _tmp4_;
#line 118 "../src/Widgets/VpnInterface.vala"
				if (_tmp5_ == connection) {
#line 702 "VpnInterface.c"
					NetworkVpnMenuItem* _tmp6_;
#line 119 "../src/Widgets/VpnInterface.vala"
					_tmp6_ = menu_item;
#line 119 "../src/Widgets/VpnInterface.vala"
					gtk_widget_destroy ((GtkWidget*) _tmp6_);
#line 120 "../src/Widgets/VpnInterface.vala"
					network_vpn_interface_check_vpn_availability (self);
#line 121 "../src/Widgets/VpnInterface.vala"
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 121 "../src/Widgets/VpnInterface.vala"
					return;
#line 714 "VpnInterface.c"
				}
			}
		}
#line 116 "../src/Widgets/VpnInterface.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 720 "VpnInterface.c"
	}
}

static NetworkVpnMenuItem*
network_vpn_interface_get_item_for_active_connection (NetworkVpnInterface* self,
                                                      NMActiveConnection* active_connection)
{
	GtkFlowBox* _tmp0_;
	GList* _tmp1_;
	NetworkVpnMenuItem* result;
#line 126 "../src/Widgets/VpnInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../src/Widgets/VpnInterface.vala"
	g_return_val_if_fail (active_connection != NULL, NULL);
#line 127 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = self->priv->vpn_list;
#line 127 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 739 "VpnInterface.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 127 "../src/Widgets/VpnInterface.vala"
		child_collection = _tmp1_;
#line 127 "../src/Widgets/VpnInterface.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 747 "VpnInterface.c"
			GtkWidget* child = NULL;
#line 127 "../src/Widgets/VpnInterface.vala"
			child = (GtkWidget*) child_it->data;
#line 751 "VpnInterface.c"
			{
				NetworkVpnMenuItem* menu_item = NULL;
				GtkWidget* _tmp2_;
				NetworkVpnMenuItem* _tmp3_;
				NMRemoteConnection* _tmp4_;
				NMRemoteConnection* _tmp5_;
				NMRemoteConnection* _tmp6_;
				NMRemoteConnection* _tmp7_;
#line 128 "../src/Widgets/VpnInterface.vala"
				_tmp2_ = child;
#line 128 "../src/Widgets/VpnInterface.vala"
				menu_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 129 "../src/Widgets/VpnInterface.vala"
				_tmp3_ = menu_item;
#line 129 "../src/Widgets/VpnInterface.vala"
				_tmp4_ = network_vpn_menu_item_get_remote_connection (_tmp3_);
#line 129 "../src/Widgets/VpnInterface.vala"
				_tmp5_ = _tmp4_;
#line 129 "../src/Widgets/VpnInterface.vala"
				_tmp6_ = nm_active_connection_get_connection (active_connection);
#line 129 "../src/Widgets/VpnInterface.vala"
				_tmp7_ = _tmp6_;
#line 129 "../src/Widgets/VpnInterface.vala"
				if (_tmp5_ == _tmp7_) {
#line 776 "VpnInterface.c"
					NetworkVpnMenuItem* _tmp8_;
					NetworkVpnMenuItem* _tmp9_;
#line 130 "../src/Widgets/VpnInterface.vala"
					_tmp8_ = menu_item;
#line 130 "../src/Widgets/VpnInterface.vala"
					_tmp9_ = _g_object_ref0 (_tmp8_);
#line 130 "../src/Widgets/VpnInterface.vala"
					result = _tmp9_;
#line 130 "../src/Widgets/VpnInterface.vala"
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 130 "../src/Widgets/VpnInterface.vala"
					return result;
#line 789 "VpnInterface.c"
				}
			}
		}
#line 127 "../src/Widgets/VpnInterface.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 795 "VpnInterface.c"
	}
#line 134 "../src/Widgets/VpnInterface.vala"
	result = NULL;
#line 134 "../src/Widgets/VpnInterface.vala"
	return result;
#line 801 "VpnInterface.c"
}

NMClient*
network_vpn_interface_get_nm_client (NetworkVpnInterface* self)
{
	NMClient* result;
	NMClient* _tmp0_;
#line 7 "../src/Widgets/VpnInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = self->priv->_nm_client;
#line 7 "../src/Widgets/VpnInterface.vala"
	result = _tmp0_;
#line 7 "../src/Widgets/VpnInterface.vala"
	return result;
#line 817 "VpnInterface.c"
}

static void
network_vpn_interface_set_nm_client (NetworkVpnInterface* self,
                                     NMClient* value)
{
	NMClient* old_value;
#line 7 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/Widgets/VpnInterface.vala"
	old_value = network_vpn_interface_get_nm_client (self);
#line 7 "../src/Widgets/VpnInterface.vala"
	if (old_value != value) {
#line 831 "VpnInterface.c"
		NMClient* _tmp0_;
#line 7 "../src/Widgets/VpnInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 7 "../src/Widgets/VpnInterface.vala"
		_g_object_unref0 (self->priv->_nm_client);
#line 7 "../src/Widgets/VpnInterface.vala"
		self->priv->_nm_client = _tmp0_;
#line 7 "../src/Widgets/VpnInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY]);
#line 841 "VpnInterface.c"
	}
}

static void
_network_vpn_interface___lambda24_ (NetworkVpnInterface* self,
                                    NMRemoteConnection* connection)
{
#line 30 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (connection != NULL);
#line 30 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_vpn_added_cb (self, (GObject*) connection);
#line 853 "VpnInterface.c"
}

static void
__network_vpn_interface___lambda24__gfunc (gconstpointer data,
                                           gpointer self)
{
#line 30 "../src/Widgets/VpnInterface.vala"
	_network_vpn_interface___lambda24_ ((NetworkVpnInterface*) self, (NMRemoteConnection*) data);
#line 862 "VpnInterface.c"
}

static void
_network_vpn_interface___lambda25_ (NetworkVpnInterface* self,
                                    NMActiveConnection* connection)
{
#line 31 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (connection != NULL);
#line 31 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_active_connected_added_cb (self, connection);
#line 873 "VpnInterface.c"
}

static void
__network_vpn_interface___lambda25__gfunc (gconstpointer data,
                                           gpointer self)
{
#line 31 "../src/Widgets/VpnInterface.vala"
	_network_vpn_interface___lambda25_ ((NetworkVpnInterface*) self, (NMActiveConnection*) data);
#line 882 "VpnInterface.c"
}

static void
_network_vpn_interface_check_vpn_availability_gtk_container_add (GtkContainer* _sender,
                                                                 GtkWidget* widget,
                                                                 gpointer self)
{
#line 35 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_check_vpn_availability ((NetworkVpnInterface*) self);
#line 892 "VpnInterface.c"
}

static void
_network_vpn_interface_check_vpn_availability_gtk_container_remove (GtkContainer* _sender,
                                                                    GtkWidget* widget,
                                                                    gpointer self)
{
#line 36 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_check_vpn_availability ((NetworkVpnInterface*) self);
#line 902 "VpnInterface.c"
}

static void
_network_vpn_interface_vpn_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                NMRemoteConnection* connection,
                                                                gpointer self)
{
#line 38 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_vpn_added_cb ((NetworkVpnInterface*) self, connection);
#line 912 "VpnInterface.c"
}

static void
_network_vpn_interface_vpn_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                    NMRemoteConnection* connection,
                                                                    gpointer self)
{
#line 39 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_vpn_removed_cb ((NetworkVpnInterface*) self, connection);
#line 922 "VpnInterface.c"
}

static void
_network_vpn_interface_active_connected_added_cb_nm_client_active_connection_added (NMClient* _sender,
                                                                                    NMActiveConnection* active_connection,
                                                                                    gpointer self)
{
#line 41 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_active_connected_added_cb ((NetworkVpnInterface*) self, active_connection);
#line 932 "VpnInterface.c"
}

static void
_network_vpn_interface_active_connected_removed_cb_nm_client_active_connection_removed (NMClient* _sender,
                                                                                        NMActiveConnection* active_connection,
                                                                                        gpointer self)
{
#line 42 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_active_connected_removed_cb ((NetworkVpnInterface*) self, active_connection);
#line 942 "VpnInterface.c"
}

static void
_network_vpn_interface___lambda26_ (NetworkVpnInterface* self,
                                    GtkFlowBoxChild* child)
{
#line 44 "../src/Widgets/VpnInterface.vala"
	g_return_if_fail (child != NULL);
#line 45 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_vpn_activate_cb (self, G_TYPE_CHECK_INSTANCE_CAST (child, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem));
#line 953 "VpnInterface.c"
}

static void
__network_vpn_interface___lambda26__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                                  GtkFlowBoxChild* child,
                                                                  gpointer self)
{
#line 44 "../src/Widgets/VpnInterface.vala"
	_network_vpn_interface___lambda26_ ((NetworkVpnInterface*) self, child);
#line 963 "VpnInterface.c"
}

static GObject *
network_vpn_interface_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVpnInterface * self;
	GtkFlowBox* _tmp0_ = NULL;
	GtkFlowBox* _tmp1_;
	NMClient* _tmp2_;
	GPtrArray* _tmp3_;
	NMClient* _tmp4_;
	GPtrArray* _tmp5_;
	GtkFlowBox* _tmp6_;
	GtkFlowBox* _tmp7_;
	NMClient* _tmp8_;
	NMClient* _tmp9_;
	NMClient* _tmp10_;
	NMClient* _tmp11_;
	GtkFlowBox* _tmp12_;
#line 15 "../src/Widgets/VpnInterface.vala"
	parent_class = G_OBJECT_CLASS (network_vpn_interface_parent_class);
#line 15 "../src/Widgets/VpnInterface.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 15 "../src/Widgets/VpnInterface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
#line 16 "../src/Widgets/VpnInterface.vala"
	_tmp0_ = (GtkFlowBox*) gtk_flow_box_new ();
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_flow_box_set_column_spacing (_tmp0_, (guint) 6);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_flow_box_set_row_spacing (_tmp0_, (guint) 12);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_flow_box_set_homogeneous (_tmp0_, TRUE);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, 6);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp0_, 12);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp0_, 6);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, 12);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_flow_box_set_max_children_per_line (_tmp0_, (guint) 3);
#line 16 "../src/Widgets/VpnInterface.vala"
	gtk_flow_box_set_selection_mode (_tmp0_, GTK_SELECTION_NONE);
#line 16 "../src/Widgets/VpnInterface.vala"
	g_object_ref_sink (_tmp0_);
#line 16 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (self->priv->vpn_list);
#line 16 "../src/Widgets/VpnInterface.vala"
	self->priv->vpn_list = _tmp0_;
#line 28 "../src/Widgets/VpnInterface.vala"
	_tmp1_ = self->priv->vpn_list;
#line 28 "../src/Widgets/VpnInterface.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 30 "../src/Widgets/VpnInterface.vala"
	_tmp2_ = self->priv->_nm_client;
#line 30 "../src/Widgets/VpnInterface.vala"
	_tmp3_ = nm_client_get_connections (_tmp2_);
#line 30 "../src/Widgets/VpnInterface.vala"
	g_ptr_array_foreach (_tmp3_, __network_vpn_interface___lambda24__gfunc, self);
#line 31 "../src/Widgets/VpnInterface.vala"
	_tmp4_ = self->priv->_nm_client;
#line 31 "../src/Widgets/VpnInterface.vala"
	_tmp5_ = nm_client_get_active_connections (_tmp4_);
#line 31 "../src/Widgets/VpnInterface.vala"
	g_ptr_array_foreach (_tmp5_, __network_vpn_interface___lambda25__gfunc, self);
#line 33 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_check_vpn_availability (self);
#line 35 "../src/Widgets/VpnInterface.vala"
	_tmp6_ = self->priv->vpn_list;
#line 35 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object ((GtkContainer*) _tmp6_, "add", (GCallback) _network_vpn_interface_check_vpn_availability_gtk_container_add, self, 0);
#line 36 "../src/Widgets/VpnInterface.vala"
	_tmp7_ = self->priv->vpn_list;
#line 36 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object ((GtkContainer*) _tmp7_, "remove", (GCallback) _network_vpn_interface_check_vpn_availability_gtk_container_remove, self, 0);
#line 38 "../src/Widgets/VpnInterface.vala"
	_tmp8_ = self->priv->_nm_client;
#line 38 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object (_tmp8_, "connection-added", (GCallback) _network_vpn_interface_vpn_added_cb_nm_client_connection_added, self, 0);
#line 39 "../src/Widgets/VpnInterface.vala"
	_tmp9_ = self->priv->_nm_client;
#line 39 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object (_tmp9_, "connection-removed", (GCallback) _network_vpn_interface_vpn_removed_cb_nm_client_connection_removed, self, 0);
#line 41 "../src/Widgets/VpnInterface.vala"
	_tmp10_ = self->priv->_nm_client;
#line 41 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object (_tmp10_, "active-connection-added", (GCallback) _network_vpn_interface_active_connected_added_cb_nm_client_active_connection_added, self, 0);
#line 42 "../src/Widgets/VpnInterface.vala"
	_tmp11_ = self->priv->_nm_client;
#line 42 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object (_tmp11_, "active-connection-removed", (GCallback) _network_vpn_interface_active_connected_removed_cb_nm_client_active_connection_removed, self, 0);
#line 44 "../src/Widgets/VpnInterface.vala"
	_tmp12_ = self->priv->vpn_list;
#line 44 "../src/Widgets/VpnInterface.vala"
	g_signal_connect_object (_tmp12_, "child-activated", (GCallback) __network_vpn_interface___lambda26__gtk_flow_box_child_activated, self, 0);
#line 15 "../src/Widgets/VpnInterface.vala"
	return obj;
#line 1067 "VpnInterface.c"
}

static void
network_vpn_interface_class_init (NetworkVpnInterfaceClass * klass,
                                  gpointer klass_data)
{
#line 6 "../src/Widgets/VpnInterface.vala"
	network_vpn_interface_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Widgets/VpnInterface.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVpnInterface_private_offset);
#line 6 "../src/Widgets/VpnInterface.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_interface_get_property;
#line 6 "../src/Widgets/VpnInterface.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_interface_set_property;
#line 6 "../src/Widgets/VpnInterface.vala"
	G_OBJECT_CLASS (klass)->constructor = network_vpn_interface_constructor;
#line 6 "../src/Widgets/VpnInterface.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_interface_finalize;
#line 6 "../src/Widgets/VpnInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY] = g_param_spec_object ("nm-client", "nm-client", "nm-client", nm_client_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1088 "VpnInterface.c"
}

static void
network_vpn_interface_instance_init (NetworkVpnInterface * self,
                                     gpointer klass)
{
#line 6 "../src/Widgets/VpnInterface.vala"
	self->priv = network_vpn_interface_get_instance_private (self);
#line 1097 "VpnInterface.c"
}

static void
network_vpn_interface_finalize (GObject * obj)
{
	NetworkVpnInterface * self;
#line 6 "../src/Widgets/VpnInterface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
#line 7 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (self->priv->_nm_client);
#line 9 "../src/Widgets/VpnInterface.vala"
	_g_object_unref0 (self->priv->vpn_list);
#line 6 "../src/Widgets/VpnInterface.vala"
	G_OBJECT_CLASS (network_vpn_interface_parent_class)->finalize (obj);
#line 1112 "VpnInterface.c"
}

static GType
network_vpn_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnInterface), 0, (GInstanceInitFunc) network_vpn_interface_instance_init, NULL };
	GType network_vpn_interface_type_id;
	network_vpn_interface_type_id = g_type_register_static (NETWORK_TYPE_WIDGET_NM_INTERFACE, "NetworkVpnInterface", &g_define_type_info, 0);
	NetworkVpnInterface_private_offset = g_type_add_instance_private (network_vpn_interface_type_id, sizeof (NetworkVpnInterfacePrivate));
	return network_vpn_interface_type_id;
}

GType
network_vpn_interface_get_type (void)
{
	static volatile gsize network_vpn_interface_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_interface_type_id__once)) {
		GType network_vpn_interface_type_id;
		network_vpn_interface_type_id = network_vpn_interface_get_type_once ();
		g_once_init_leave (&network_vpn_interface_type_id__once, network_vpn_interface_type_id);
	}
	return network_vpn_interface_type_id__once;
}

static void
_vala_network_vpn_interface_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
#line 6 "../src/Widgets/VpnInterface.vala"
	switch (property_id) {
#line 6 "../src/Widgets/VpnInterface.vala"
		case NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY:
#line 6 "../src/Widgets/VpnInterface.vala"
		g_value_set_object (value, network_vpn_interface_get_nm_client (self));
#line 6 "../src/Widgets/VpnInterface.vala"
		break;
#line 1153 "VpnInterface.c"
		default:
#line 6 "../src/Widgets/VpnInterface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/VpnInterface.vala"
		break;
#line 1159 "VpnInterface.c"
	}
}

static void
_vala_network_vpn_interface_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
#line 6 "../src/Widgets/VpnInterface.vala"
	switch (property_id) {
#line 6 "../src/Widgets/VpnInterface.vala"
		case NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY:
#line 6 "../src/Widgets/VpnInterface.vala"
		network_vpn_interface_set_nm_client (self, g_value_get_object (value));
#line 6 "../src/Widgets/VpnInterface.vala"
		break;
#line 1179 "VpnInterface.c"
		default:
#line 6 "../src/Widgets/VpnInterface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/VpnInterface.vala"
		break;
#line 1185 "VpnInterface.c"
	}
}

