/* VpnMenuItem.c generated by valac 0.56.14, the Vala compiler
 * generated from VpnMenuItem.vala, do not modify */

/*
* SPDX-License-Identifier: LGPL-2.1-or-later
* SPDX-FileCopyrightText: 2017-2023 elementary, Inc. (https://elementary.io)
*/

#include "network.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <granite.h>
#include <gdk/gdk.h>

enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

struct _NetworkVpnMenuItemPrivate {
	NMRemoteConnection* _remote_connection;
	NMActiveConnection* _vpn_connection;
	GtkToggleButton* toggle_button;
};

struct _Block6Data {
	int _ref_count_;
	NetworkVpnMenuItem* self;
	GtkLabel* label;
};

static gint NetworkVpnMenuItem_private_offset;
static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkCssProvider* network_vpn_menu_item_provider;
static GtkCssProvider* network_vpn_menu_item_provider = NULL;

static void network_vpn_menu_item_update_state (NetworkVpnMenuItem* self);
static void _network_vpn_menu_item_update_state_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                              guint object,
                                                                              guint p0,
                                                                              gpointer self);
static void _network_vpn_menu_item_update_state_nm_active_connection_state_changed (NMActiveConnection* _sender,
                                                                             guint state,
                                                                             guint reason,
                                                                             gpointer self);
static GObject * network_vpn_menu_item_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean _network_vpn_menu_item___lambda20_ (NetworkVpnMenuItem* self,
                                             GtkWidget* b,
                                             GdkEventButton* ev);
static gboolean __network_vpn_menu_item___lambda20__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self);
static void _network_vpn_menu_item___lambda21_ (Block6Data* _data6_);
static void __network_vpn_menu_item___lambda21__nm_connection_changed (NMConnection* _sender,
                                                                gpointer self);
static void network_vpn_menu_item_finalize (GObject * obj);
static GType network_vpn_menu_item_get_type_once (void);
static void _vala_network_vpn_menu_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_menu_item_get_instance_private (NetworkVpnMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVpnMenuItem_private_offset);
}

NetworkVpnMenuItem*
network_vpn_menu_item_construct (GType object_type,
                                 NMRemoteConnection* remote_connection)
{
	NetworkVpnMenuItem * self = NULL;
#line 47 "../src/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (remote_connection != NULL, NULL);
#line 48 "../src/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, "remote-connection", remote_connection, NULL);
#line 47 "../src/Widgets/VpnMenuItem.vala"
	return self;
#line 99 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_new (NMRemoteConnection* remote_connection)
{
#line 47 "../src/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, remote_connection);
#line 107 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_update_state (NetworkVpnMenuItem* self)
{
	NMActiveConnection* _tmp0_;
	const gchar* connection_type = NULL;
	NMActiveConnection* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 91 "../src/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_vpn_connection;
#line 92 "../src/Widgets/VpnMenuItem.vala"
	if (_tmp0_ == NULL) {
#line 124 "VpnMenuItem.c"
		GtkToggleButton* _tmp1_;
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkToggleButton* _tmp4_;
#line 93 "../src/Widgets/VpnMenuItem.vala"
		_tmp1_ = self->priv->toggle_button;
#line 93 "../src/Widgets/VpnMenuItem.vala"
		_tmp2_ = gtk_button_get_image ((GtkButton*) _tmp1_);
#line 93 "../src/Widgets/VpnMenuItem.vala"
		_tmp3_ = _tmp2_;
#line 93 "../src/Widgets/VpnMenuItem.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-disconnected-symbolic", NULL);
#line 94 "../src/Widgets/VpnMenuItem.vala"
		_tmp4_ = self->priv->toggle_button;
#line 94 "../src/Widgets/VpnMenuItem.vala"
		gtk_toggle_button_set_active (_tmp4_, FALSE);
#line 95 "../src/Widgets/VpnMenuItem.vala"
		return;
#line 143 "VpnMenuItem.c"
	}
#line 97 "../src/Widgets/VpnMenuItem.vala"
	_tmp5_ = self->priv->_vpn_connection;
#line 97 "../src/Widgets/VpnMenuItem.vala"
	_tmp6_ = nm_active_connection_get_connection_type (_tmp5_);
#line 97 "../src/Widgets/VpnMenuItem.vala"
	connection_type = _tmp6_;
#line 98 "../src/Widgets/VpnMenuItem.vala"
	_tmp7_ = connection_type;
#line 98 "../src/Widgets/VpnMenuItem.vala"
	if (g_strcmp0 (_tmp7_, NM_SETTING_VPN_SETTING_NAME) == 0) {
#line 155 "VpnMenuItem.c"
		NMActiveConnection* _tmp8_;
		NMVpnConnectionState _tmp9_;
		NMVpnConnectionState _tmp10_;
#line 99 "../src/Widgets/VpnMenuItem.vala"
		_tmp8_ = self->priv->_vpn_connection;
#line 99 "../src/Widgets/VpnMenuItem.vala"
		_tmp9_ = nm_vpn_connection_get_vpn_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, nm_vpn_connection_get_type (), NMVpnConnection));
#line 99 "../src/Widgets/VpnMenuItem.vala"
		_tmp10_ = _tmp9_;
#line 99 "../src/Widgets/VpnMenuItem.vala"
		switch (_tmp10_) {
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_CONNECT:
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_IP_CONFIG_GET:
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_NEED_AUTH:
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_PREPARE:
#line 175 "VpnMenuItem.c"
			{
				GtkToggleButton* _tmp11_;
				GtkWidget* _tmp12_;
				GtkWidget* _tmp13_;
#line 104 "../src/Widgets/VpnMenuItem.vala"
				_tmp11_ = self->priv->toggle_button;
#line 104 "../src/Widgets/VpnMenuItem.vala"
				_tmp12_ = gtk_button_get_image ((GtkButton*) _tmp11_);
#line 104 "../src/Widgets/VpnMenuItem.vala"
				_tmp13_ = _tmp12_;
#line 104 "../src/Widgets/VpnMenuItem.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-acquiring-symbolic", NULL);
#line 105 "../src/Widgets/VpnMenuItem.vala"
				break;
#line 190 "VpnMenuItem.c"
			}
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_ACTIVATED:
#line 194 "VpnMenuItem.c"
			{
				GtkToggleButton* _tmp14_;
				GtkWidget* _tmp15_;
				GtkWidget* _tmp16_;
				GtkToggleButton* _tmp17_;
#line 107 "../src/Widgets/VpnMenuItem.vala"
				_tmp14_ = self->priv->toggle_button;
#line 107 "../src/Widgets/VpnMenuItem.vala"
				_tmp15_ = gtk_button_get_image ((GtkButton*) _tmp14_);
#line 107 "../src/Widgets/VpnMenuItem.vala"
				_tmp16_ = _tmp15_;
#line 107 "../src/Widgets/VpnMenuItem.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-connected-symbolic", NULL);
#line 108 "../src/Widgets/VpnMenuItem.vala"
				_tmp17_ = self->priv->toggle_button;
#line 108 "../src/Widgets/VpnMenuItem.vala"
				gtk_toggle_button_set_active (_tmp17_, TRUE);
#line 109 "../src/Widgets/VpnMenuItem.vala"
				break;
#line 214 "VpnMenuItem.c"
			}
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_DISCONNECTED:
#line 218 "VpnMenuItem.c"
			{
				GtkToggleButton* _tmp18_;
				GtkWidget* _tmp19_;
				GtkWidget* _tmp20_;
				GtkToggleButton* _tmp21_;
#line 111 "../src/Widgets/VpnMenuItem.vala"
				_tmp18_ = self->priv->toggle_button;
#line 111 "../src/Widgets/VpnMenuItem.vala"
				_tmp19_ = gtk_button_get_image ((GtkButton*) _tmp18_);
#line 111 "../src/Widgets/VpnMenuItem.vala"
				_tmp20_ = _tmp19_;
#line 111 "../src/Widgets/VpnMenuItem.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-disconnected-symbolic", NULL);
#line 112 "../src/Widgets/VpnMenuItem.vala"
				_tmp21_ = self->priv->toggle_button;
#line 112 "../src/Widgets/VpnMenuItem.vala"
				gtk_toggle_button_set_active (_tmp21_, FALSE);
#line 113 "../src/Widgets/VpnMenuItem.vala"
				break;
#line 238 "VpnMenuItem.c"
			}
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_FAILED:
#line 99 "../src/Widgets/VpnMenuItem.vala"
			case NM_VPN_CONNECTION_STATE_UNKNOWN:
#line 244 "VpnMenuItem.c"
			{
				GtkToggleButton* _tmp22_;
				GtkWidget* _tmp23_;
				GtkWidget* _tmp24_;
				GtkToggleButton* _tmp25_;
#line 116 "../src/Widgets/VpnMenuItem.vala"
				_tmp22_ = self->priv->toggle_button;
#line 116 "../src/Widgets/VpnMenuItem.vala"
				_tmp23_ = gtk_button_get_image ((GtkButton*) _tmp22_);
#line 116 "../src/Widgets/VpnMenuItem.vala"
				_tmp24_ = _tmp23_;
#line 116 "../src/Widgets/VpnMenuItem.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-error-symbolic", NULL);
#line 117 "../src/Widgets/VpnMenuItem.vala"
				_tmp25_ = self->priv->toggle_button;
#line 117 "../src/Widgets/VpnMenuItem.vala"
				gtk_toggle_button_set_active (_tmp25_, FALSE);
#line 118 "../src/Widgets/VpnMenuItem.vala"
				break;
#line 264 "VpnMenuItem.c"
			}
			default:
#line 99 "../src/Widgets/VpnMenuItem.vala"
			break;
#line 269 "VpnMenuItem.c"
		}
	} else {
		const gchar* _tmp26_;
#line 120 "../src/Widgets/VpnMenuItem.vala"
		_tmp26_ = connection_type;
#line 120 "../src/Widgets/VpnMenuItem.vala"
		if (g_strcmp0 (_tmp26_, NM_SETTING_WIREGUARD_SETTING_NAME) == 0) {
#line 277 "VpnMenuItem.c"
			NMActiveConnection* _tmp27_;
#line 121 "../src/Widgets/VpnMenuItem.vala"
			_tmp27_ = self->priv->_vpn_connection;
#line 121 "../src/Widgets/VpnMenuItem.vala"
			switch (nm_active_connection_get_state (_tmp27_)) {
#line 121 "../src/Widgets/VpnMenuItem.vala"
				case NM_ACTIVE_CONNECTION_STATE_UNKNOWN:
#line 285 "VpnMenuItem.c"
				{
					GtkToggleButton* _tmp28_;
					GtkWidget* _tmp29_;
					GtkWidget* _tmp30_;
					GtkToggleButton* _tmp31_;
#line 123 "../src/Widgets/VpnMenuItem.vala"
					_tmp28_ = self->priv->toggle_button;
#line 123 "../src/Widgets/VpnMenuItem.vala"
					_tmp29_ = gtk_button_get_image ((GtkButton*) _tmp28_);
#line 123 "../src/Widgets/VpnMenuItem.vala"
					_tmp30_ = _tmp29_;
#line 123 "../src/Widgets/VpnMenuItem.vala"
					g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-error-symbolic", NULL);
#line 124 "../src/Widgets/VpnMenuItem.vala"
					_tmp31_ = self->priv->toggle_button;
#line 124 "../src/Widgets/VpnMenuItem.vala"
					gtk_toggle_button_set_active (_tmp31_, FALSE);
#line 125 "../src/Widgets/VpnMenuItem.vala"
					break;
#line 305 "VpnMenuItem.c"
				}
#line 121 "../src/Widgets/VpnMenuItem.vala"
				case NM_ACTIVE_CONNECTION_STATE_DEACTIVATED:
#line 121 "../src/Widgets/VpnMenuItem.vala"
				case NM_ACTIVE_CONNECTION_STATE_DEACTIVATING:
#line 311 "VpnMenuItem.c"
				{
					GtkToggleButton* _tmp32_;
					GtkWidget* _tmp33_;
					GtkWidget* _tmp34_;
					GtkToggleButton* _tmp35_;
#line 128 "../src/Widgets/VpnMenuItem.vala"
					_tmp32_ = self->priv->toggle_button;
#line 128 "../src/Widgets/VpnMenuItem.vala"
					_tmp33_ = gtk_button_get_image ((GtkButton*) _tmp32_);
#line 128 "../src/Widgets/VpnMenuItem.vala"
					_tmp34_ = _tmp33_;
#line 128 "../src/Widgets/VpnMenuItem.vala"
					g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-disconnected-symbolic", NULL);
#line 129 "../src/Widgets/VpnMenuItem.vala"
					_tmp35_ = self->priv->toggle_button;
#line 129 "../src/Widgets/VpnMenuItem.vala"
					gtk_toggle_button_set_active (_tmp35_, FALSE);
#line 130 "../src/Widgets/VpnMenuItem.vala"
					break;
#line 331 "VpnMenuItem.c"
				}
#line 121 "../src/Widgets/VpnMenuItem.vala"
				case NM_ACTIVE_CONNECTION_STATE_ACTIVATING:
#line 335 "VpnMenuItem.c"
				{
					GtkToggleButton* _tmp36_;
					GtkWidget* _tmp37_;
					GtkWidget* _tmp38_;
#line 132 "../src/Widgets/VpnMenuItem.vala"
					_tmp36_ = self->priv->toggle_button;
#line 132 "../src/Widgets/VpnMenuItem.vala"
					_tmp37_ = gtk_button_get_image ((GtkButton*) _tmp36_);
#line 132 "../src/Widgets/VpnMenuItem.vala"
					_tmp38_ = _tmp37_;
#line 132 "../src/Widgets/VpnMenuItem.vala"
					g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-acquiring-symbolic", NULL);
#line 133 "../src/Widgets/VpnMenuItem.vala"
					break;
#line 350 "VpnMenuItem.c"
				}
#line 121 "../src/Widgets/VpnMenuItem.vala"
				case NM_ACTIVE_CONNECTION_STATE_ACTIVATED:
#line 354 "VpnMenuItem.c"
				{
					GtkToggleButton* _tmp39_;
					GtkWidget* _tmp40_;
					GtkWidget* _tmp41_;
					GtkToggleButton* _tmp42_;
#line 135 "../src/Widgets/VpnMenuItem.vala"
					_tmp39_ = self->priv->toggle_button;
#line 135 "../src/Widgets/VpnMenuItem.vala"
					_tmp40_ = gtk_button_get_image ((GtkButton*) _tmp39_);
#line 135 "../src/Widgets/VpnMenuItem.vala"
					_tmp41_ = _tmp40_;
#line 135 "../src/Widgets/VpnMenuItem.vala"
					g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-connected-symbolic", NULL);
#line 136 "../src/Widgets/VpnMenuItem.vala"
					_tmp42_ = self->priv->toggle_button;
#line 136 "../src/Widgets/VpnMenuItem.vala"
					gtk_toggle_button_set_active (_tmp42_, TRUE);
#line 137 "../src/Widgets/VpnMenuItem.vala"
					break;
#line 374 "VpnMenuItem.c"
				}
				default:
#line 121 "../src/Widgets/VpnMenuItem.vala"
				break;
#line 379 "VpnMenuItem.c"
			}
		}
	}
}

NMRemoteConnection*
network_vpn_menu_item_get_remote_connection (NetworkVpnMenuItem* self)
{
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
#line 7 "../src/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_remote_connection;
#line 7 "../src/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 7 "../src/Widgets/VpnMenuItem.vala"
	return result;
#line 398 "VpnMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 7 "../src/Widgets/VpnMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 406 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_set_remote_connection (NetworkVpnMenuItem* self,
                                             NMRemoteConnection* value)
{
	NMRemoteConnection* old_value;
#line 7 "../src/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/Widgets/VpnMenuItem.vala"
	old_value = network_vpn_menu_item_get_remote_connection (self);
#line 7 "../src/Widgets/VpnMenuItem.vala"
	if (old_value != value) {
#line 420 "VpnMenuItem.c"
		NMRemoteConnection* _tmp0_;
#line 7 "../src/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 7 "../src/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_remote_connection);
#line 7 "../src/Widgets/VpnMenuItem.vala"
		self->priv->_remote_connection = _tmp0_;
#line 7 "../src/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY]);
#line 430 "VpnMenuItem.c"
	}
}

NMActiveConnection*
network_vpn_menu_item_get_vpn_connection (NetworkVpnMenuItem* self)
{
	NMActiveConnection* result;
	NMActiveConnection* _tmp0_;
#line 12 "../src/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_vpn_connection;
#line 13 "../src/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/VpnMenuItem.vala"
	return result;
#line 447 "VpnMenuItem.c"
}

static void
_network_vpn_menu_item_update_state_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                         guint object,
                                                                         guint p0,
                                                                         gpointer self)
{
#line 23 "../src/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update_state ((NetworkVpnMenuItem*) self);
#line 458 "VpnMenuItem.c"
}

static void
_network_vpn_menu_item_update_state_nm_active_connection_state_changed (NMActiveConnection* _sender,
                                                                        guint state,
                                                                        guint reason,
                                                                        gpointer self)
{
#line 25 "../src/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update_state ((NetworkVpnMenuItem*) self);
#line 469 "VpnMenuItem.c"
}

void
network_vpn_menu_item_set_vpn_connection (NetworkVpnMenuItem* self,
                                          NMActiveConnection* value)
{
	NMActiveConnection* _tmp3_;
	GtkToggleButton* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* _tmp11_;
	GtkToggleButton* _tmp12_;
#line 15 "../src/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/Widgets/VpnMenuItem.vala"
	if (value != NULL) {
#line 485 "VpnMenuItem.c"
		NMActiveConnection* _tmp0_;
#line 17 "../src/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 17 "../src/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_vpn_connection);
#line 17 "../src/Widgets/VpnMenuItem.vala"
		self->priv->_vpn_connection = _tmp0_;
#line 22 "../src/Widgets/VpnMenuItem.vala"
		if (nm_active_connection_get_vpn (value)) {
#line 495 "VpnMenuItem.c"
			NMActiveConnection* _tmp1_;
#line 23 "../src/Widgets/VpnMenuItem.vala"
			_tmp1_ = self->priv->_vpn_connection;
#line 23 "../src/Widgets/VpnMenuItem.vala"
			g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, nm_vpn_connection_get_type (), NMVpnConnection), "vpn-state-changed", (GCallback) _network_vpn_menu_item_update_state_nm_vpn_connection_vpn_state_changed, self, 0);
#line 501 "VpnMenuItem.c"
		} else {
			NMActiveConnection* _tmp2_;
#line 25 "../src/Widgets/VpnMenuItem.vala"
			_tmp2_ = self->priv->_vpn_connection;
#line 25 "../src/Widgets/VpnMenuItem.vala"
			g_signal_connect_object (_tmp2_, "state-changed", (GCallback) _network_vpn_menu_item_update_state_nm_active_connection_state_changed, self, 0);
#line 508 "VpnMenuItem.c"
		}
#line 27 "../src/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_update_state (self);
#line 28 "../src/Widgets/VpnMenuItem.vala"
		return;
#line 514 "VpnMenuItem.c"
	}
#line 30 "../src/Widgets/VpnMenuItem.vala"
	_tmp3_ = self->priv->_vpn_connection;
#line 30 "../src/Widgets/VpnMenuItem.vala"
	if (_tmp3_ != NULL) {
#line 520 "VpnMenuItem.c"
		NMActiveConnection* _tmp4_;
#line 31 "../src/Widgets/VpnMenuItem.vala"
		_tmp4_ = self->priv->_vpn_connection;
#line 31 "../src/Widgets/VpnMenuItem.vala"
		if (nm_active_connection_get_vpn (_tmp4_)) {
#line 526 "VpnMenuItem.c"
			NMActiveConnection* _tmp5_;
			guint _tmp6_;
#line 32 "../src/Widgets/VpnMenuItem.vala"
			_tmp5_ = self->priv->_vpn_connection;
#line 32 "../src/Widgets/VpnMenuItem.vala"
			g_signal_parse_name ("vpn-state-changed", nm_vpn_connection_get_type (), &_tmp6_, NULL, FALSE);
#line 32 "../src/Widgets/VpnMenuItem.vala"
			g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, nm_vpn_connection_get_type (), NMVpnConnection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _network_vpn_menu_item_update_state_nm_vpn_connection_vpn_state_changed, self);
#line 535 "VpnMenuItem.c"
		} else {
			NMActiveConnection* _tmp7_;
			guint _tmp8_;
#line 34 "../src/Widgets/VpnMenuItem.vala"
			_tmp7_ = self->priv->_vpn_connection;
#line 34 "../src/Widgets/VpnMenuItem.vala"
			g_signal_parse_name ("state-changed", nm_active_connection_get_type (), &_tmp8_, NULL, FALSE);
#line 34 "../src/Widgets/VpnMenuItem.vala"
			g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _network_vpn_menu_item_update_state_nm_active_connection_state_changed, self);
#line 545 "VpnMenuItem.c"
		}
#line 36 "../src/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_vpn_connection);
#line 36 "../src/Widgets/VpnMenuItem.vala"
		self->priv->_vpn_connection = NULL;
#line 551 "VpnMenuItem.c"
	}
#line 39 "../src/Widgets/VpnMenuItem.vala"
	_tmp9_ = self->priv->toggle_button;
#line 39 "../src/Widgets/VpnMenuItem.vala"
	_tmp10_ = gtk_button_get_image ((GtkButton*) _tmp9_);
#line 39 "../src/Widgets/VpnMenuItem.vala"
	_tmp11_ = _tmp10_;
#line 39 "../src/Widgets/VpnMenuItem.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_image_get_type (), GtkImage), "icon-name", "panel-network-vpn-disconnected-symbolic", NULL);
#line 40 "../src/Widgets/VpnMenuItem.vala"
	_tmp12_ = self->priv->toggle_button;
#line 40 "../src/Widgets/VpnMenuItem.vala"
	gtk_toggle_button_set_active (_tmp12_, FALSE);
#line 15 "../src/Widgets/VpnMenuItem.vala"
	g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY]);
#line 567 "VpnMenuItem.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 56 "../src/Widgets/VpnMenuItem.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	return _data6_;
#line 577 "VpnMenuItem.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 56 "../src/Widgets/VpnMenuItem.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 587 "VpnMenuItem.c"
		NetworkVpnMenuItem* self;
#line 56 "../src/Widgets/VpnMenuItem.vala"
		self = _data6_->self;
#line 56 "../src/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (_data6_->label);
#line 56 "../src/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self);
#line 56 "../src/Widgets/VpnMenuItem.vala"
		g_slice_free (Block6Data, _data6_);
#line 597 "VpnMenuItem.c"
	}
}

static gboolean
_network_vpn_menu_item___lambda20_ (NetworkVpnMenuItem* self,
                                    GtkWidget* b,
                                    GdkEventButton* ev)
{
	gboolean result;
#line 81 "../src/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 81 "../src/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 82 "../src/Widgets/VpnMenuItem.vala"
	g_signal_emit_by_name ((GtkFlowBoxChild*) self, "activate");
#line 83 "../src/Widgets/VpnMenuItem.vala"
	result = GDK_EVENT_STOP;
#line 83 "../src/Widgets/VpnMenuItem.vala"
	return result;
#line 617 "VpnMenuItem.c"
}

static gboolean
__network_vpn_menu_item___lambda20__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self)
{
	gboolean result;
	result = _network_vpn_menu_item___lambda20_ ((NetworkVpnMenuItem*) self, _sender, event);
#line 81 "../src/Widgets/VpnMenuItem.vala"
	return result;
#line 629 "VpnMenuItem.c"
}

static void
_network_vpn_menu_item___lambda21_ (Block6Data* _data6_)
{
	NetworkVpnMenuItem* self;
	GtkLabel* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
#line 86 "../src/Widgets/VpnMenuItem.vala"
	self = _data6_->self;
#line 87 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = _data6_->label;
#line 87 "../src/Widgets/VpnMenuItem.vala"
	_tmp1_ = self->priv->_remote_connection;
#line 87 "../src/Widgets/VpnMenuItem.vala"
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
#line 87 "../src/Widgets/VpnMenuItem.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 649 "VpnMenuItem.c"
}

static void
__network_vpn_menu_item___lambda21__nm_connection_changed (NMConnection* _sender,
                                                           gpointer self)
{
#line 86 "../src/Widgets/VpnMenuItem.vala"
	_network_vpn_menu_item___lambda21_ (self);
#line 658 "VpnMenuItem.c"
}

static GObject *
network_vpn_menu_item_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVpnMenuItem * self;
	Block6Data* _data6_;
	GtkImage* _tmp0_;
	GtkToggleButton* _tmp1_ = NULL;
	GtkToggleButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkCssProvider* _tmp6_;
	NMRemoteConnection* _tmp7_;
	const gchar* _tmp8_;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkBox* box = NULL;
	GtkBox* _tmp12_ = NULL;
	GtkBox* _tmp13_;
	GtkToggleButton* _tmp14_;
	GtkBox* _tmp15_;
	GtkLabel* _tmp16_;
	GtkBox* _tmp17_;
	GtkToggleButton* _tmp18_;
	NMRemoteConnection* _tmp19_;
#line 56 "../src/Widgets/VpnMenuItem.vala"
	parent_class = G_OBJECT_CLASS (network_vpn_menu_item_parent_class);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	_data6_->_ref_count_ = 1;
#line 56 "../src/Widgets/VpnMenuItem.vala"
	_data6_->self = g_object_ref (self);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("panel-network-vpn-disconnected-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	_tmp1_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 57 "../src/Widgets/VpnMenuItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	gtk_button_set_image ((GtkButton*) _tmp1_, (GtkWidget*) _tmp0_);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp0_);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->toggle_button);
#line 57 "../src/Widgets/VpnMenuItem.vala"
	self->priv->toggle_button = _tmp1_;
#line 61 "../src/Widgets/VpnMenuItem.vala"
	_tmp2_ = self->priv->toggle_button;
#line 61 "../src/Widgets/VpnMenuItem.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 61 "../src/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_class (_tmp3_, "circular");
#line 62 "../src/Widgets/VpnMenuItem.vala"
	_tmp4_ = self->priv->toggle_button;
#line 62 "../src/Widgets/VpnMenuItem.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 62 "../src/Widgets/VpnMenuItem.vala"
	_tmp6_ = network_vpn_menu_item_provider;
#line 62 "../src/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_provider (_tmp5_, (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	_tmp7_ = self->priv->_remote_connection;
#line 65 "../src/Widgets/VpnMenuItem.vala"
	_tmp8_ = nm_connection_get_id ((NMConnection*) _tmp7_);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	gtk_label_set_ellipsize (_tmp9_, PANGO_ELLIPSIZE_MIDDLE);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	gtk_label_set_max_width_chars (_tmp9_, 16);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp9_);
#line 65 "../src/Widgets/VpnMenuItem.vala"
	_data6_->label = _tmp9_;
#line 69 "../src/Widgets/VpnMenuItem.vala"
	_tmp10_ = _data6_->label;
#line 69 "../src/Widgets/VpnMenuItem.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 69 "../src/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_class (_tmp11_, GRANITE_STYLE_CLASS_SMALL_LABEL);
#line 71 "../src/Widgets/VpnMenuItem.vala"
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 3);
#line 71 "../src/Widgets/VpnMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 71 "../src/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp12_);
#line 71 "../src/Widgets/VpnMenuItem.vala"
	box = _tmp12_;
#line 74 "../src/Widgets/VpnMenuItem.vala"
	_tmp13_ = box;
#line 74 "../src/Widgets/VpnMenuItem.vala"
	_tmp14_ = self->priv->toggle_button;
#line 74 "../src/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 75 "../src/Widgets/VpnMenuItem.vala"
	_tmp15_ = box;
#line 75 "../src/Widgets/VpnMenuItem.vala"
	_tmp16_ = _data6_->label;
#line 75 "../src/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 77 "../src/Widgets/VpnMenuItem.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 78 "../src/Widgets/VpnMenuItem.vala"
	_tmp17_ = box;
#line 78 "../src/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
#line 81 "../src/Widgets/VpnMenuItem.vala"
	_tmp18_ = self->priv->toggle_button;
#line 81 "../src/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "button-release-event", (GCallback) __network_vpn_menu_item___lambda20__gtk_widget_button_release_event, self, 0);
#line 86 "../src/Widgets/VpnMenuItem.vala"
	_tmp19_ = self->priv->_remote_connection;
#line 86 "../src/Widgets/VpnMenuItem.vala"
	g_signal_connect_data ((NMConnection*) _tmp19_, "changed", (GCallback) __network_vpn_menu_item___lambda21__nm_connection_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (box);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	block6_data_unref (_data6_);
#line 56 "../src/Widgets/VpnMenuItem.vala"
	_data6_ = NULL;
#line 56 "../src/Widgets/VpnMenuItem.vala"
	return obj;
#line 797 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_class_init (NetworkVpnMenuItemClass * klass,
                                  gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/Widgets/VpnMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVpnMenuItem_private_offset);
#line 6 "../src/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->constructor = network_vpn_menu_item_constructor;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY] = g_param_spec_object ("remote-connection", "remote-connection", "remote-connection", nm_remote_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY] = g_param_spec_object ("vpn-connection", "vpn-connection", "vpn-connection", nm_active_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 52 "../src/Widgets/VpnMenuItem.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 52 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (network_vpn_menu_item_provider);
#line 52 "../src/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_provider = _tmp0_;
#line 53 "../src/Widgets/VpnMenuItem.vala"
	_tmp1_ = network_vpn_menu_item_provider;
#line 53 "../src/Widgets/VpnMenuItem.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "io/elementary/wingpanel/network/Indicator.css");
#line 832 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_instance_init (NetworkVpnMenuItem * self,
                                     gpointer klass)
{
#line 6 "../src/Widgets/VpnMenuItem.vala"
	self->priv = network_vpn_menu_item_get_instance_private (self);
#line 8 "../src/Widgets/VpnMenuItem.vala"
	self->cancellable = NULL;
#line 10 "../src/Widgets/VpnMenuItem.vala"
	self->priv->_vpn_connection = NULL;
#line 845 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_finalize (GObject * obj)
{
	NetworkVpnMenuItem * self;
#line 6 "../src/Widgets/VpnMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 7 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_remote_connection);
#line 8 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->cancellable);
#line 10 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_vpn_connection);
#line 45 "../src/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->toggle_button);
#line 6 "../src/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
#line 864 "VpnMenuItem.c"
}

static GType
network_vpn_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
	GType network_vpn_menu_item_type_id;
	network_vpn_menu_item_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "NetworkVpnMenuItem", &g_define_type_info, 0);
	NetworkVpnMenuItem_private_offset = g_type_add_instance_private (network_vpn_menu_item_type_id, sizeof (NetworkVpnMenuItemPrivate));
	return network_vpn_menu_item_type_id;
}

GType
network_vpn_menu_item_get_type (void)
{
	static volatile gsize network_vpn_menu_item_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__once)) {
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = network_vpn_menu_item_get_type_once ();
		g_once_init_leave (&network_vpn_menu_item_type_id__once, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__once;
}

static void
_vala_network_vpn_menu_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 6 "../src/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 6 "../src/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_remote_connection (self));
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 6 "../src/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_vpn_connection (self));
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 911 "VpnMenuItem.c"
		default:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 917 "VpnMenuItem.c"
	}
}

static void
_vala_network_vpn_menu_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 6 "../src/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 6 "../src/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_REMOTE_CONNECTION_PROPERTY:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_remote_connection (self, g_value_get_object (value));
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 6 "../src/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_CONNECTION_PROPERTY:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_vpn_connection (self, g_value_get_object (value));
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 943 "VpnMenuItem.c"
		default:
#line 6 "../src/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/Widgets/VpnMenuItem.vala"
		break;
#line 949 "VpnMenuItem.c"
	}
}

