/* WifiMenuItem.c generated by valac 0.56.14, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*
 * Copyright 2015-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "network.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "panel-network-wireless-signal-%s-symbolic"

enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_AP_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetworkWifiMenuItemPrivate {
	NMAccessPoint* _ap;
	NMDeviceState _state;
	GtkImage* error_img;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkLabel* label;
	GtkRadioButton* radio_button;
	GtkSpinner* spinner;
	GList* ap_list;
};

static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static gboolean __lambda9_ (NetworkWifiMenuItem* self,
                     GtkWidget* b,
                     GdkEventButton* ev);
static gboolean ___lambda9__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void network_wifi_menu_item_update_ap (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_set_ap (NetworkWifiMenuItem* self,
                                    NMAccessPoint* value);
static void network_wifi_menu_item_finalize (GObject * obj);
static GType network_wifi_menu_item_get_type_once (void);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 50 "../src/Widgets/WifiMenuItem.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 100 "WifiMenuItem.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 50 "../src/Widgets/WifiMenuItem.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 108 "WifiMenuItem.c"
}

static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 88 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
#line 118 "WifiMenuItem.c"
}

static gboolean
__lambda9_ (NetworkWifiMenuItem* self,
            GtkWidget* b,
            GdkEventButton* ev)
{
	gboolean result;
#line 91 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 91 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 92 "../src/Widgets/WifiMenuItem.vala"
	g_signal_emit_by_name ((GtkListBoxRow*) self, "activate");
#line 93 "../src/Widgets/WifiMenuItem.vala"
	result = GDK_EVENT_STOP;
#line 93 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 137 "WifiMenuItem.c"
}

static gboolean
___lambda9__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda9_ ((NetworkWifiMenuItem*) self, _sender, event);
#line 91 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 149 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  GtkRadioButton* blank_radio)
{
	NetworkWifiMenuItem * self = NULL;
	GtkLabel* _tmp0_ = NULL;
	GtkRadioButton* _tmp1_ = NULL;
	GtkRadioButton* _tmp2_;
	GtkLabel* _tmp3_;
	GtkImage* _tmp4_ = NULL;
	GtkImage* _tmp5_;
	gchar* _tmp6_;
	GtkImage* _tmp7_ = NULL;
	GtkSpinner* _tmp8_;
	GtkBox* box = NULL;
	GtkBox* _tmp9_;
	GtkRadioButton* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkRadioButton* _tmp15_;
#line 52 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (blank_radio != NULL, NULL);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_MIDDLE);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->label);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	self->priv->label = _tmp0_;
#line 57 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (blank_radio);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 57 "../src/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp1_;
#line 60 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = self->priv->radio_button;
#line 60 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = self->priv->label;
#line 60 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_tmp4_ = (GtkImage*) gtk_image_new ();
#line 62 "../src/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp4_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp4_);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	self->priv->img_strength = _tmp4_;
#line 66 "../src/Widgets/WifiMenuItem.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 66 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp5_);
#line 66 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 66 "../src/Widgets/WifiMenuItem.vala"
	self->priv->lock_img = _tmp5_;
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = g_strdup (_ ("Unable to connect"));
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _tmp6_);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp6_);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp7_);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	self->priv->error_img = _tmp7_;
#line 72 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = (GtkSpinner*) gtk_spinner_new ();
#line 72 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp8_);
#line 72 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 72 "../src/Widgets/WifiMenuItem.vala"
	self->priv->spinner = _tmp8_;
#line 74 "../src/Widgets/WifiMenuItem.vala"
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 74 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp9_);
#line 74 "../src/Widgets/WifiMenuItem.vala"
	box = _tmp9_;
#line 75 "../src/Widgets/WifiMenuItem.vala"
	_tmp10_ = self->priv->radio_button;
#line 75 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp10_);
#line 76 "../src/Widgets/WifiMenuItem.vala"
	_tmp11_ = self->priv->spinner;
#line 76 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp11_);
#line 77 "../src/Widgets/WifiMenuItem.vala"
	_tmp12_ = self->priv->error_img;
#line 77 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp12_);
#line 78 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = self->priv->lock_img;
#line 78 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp13_);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->img_strength;
#line 79 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp14_);
#line 81 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
#line 83 "../src/Widgets/WifiMenuItem.vala"
	(self->priv->ap_list == NULL) ? NULL : (self->priv->ap_list = (_g_list_free__g_object_unref0_ (self->priv->ap_list), NULL));
#line 83 "../src/Widgets/WifiMenuItem.vala"
	self->priv->ap_list = NULL;
#line 86 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_add_ap (self, ap);
#line 88 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 91 "../src/Widgets/WifiMenuItem.vala"
	_tmp15_ = self->priv->radio_button;
#line 91 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp15_, "button-release-event", (GCallback) ___lambda9__gtk_widget_button_release_event, self, 0);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (box);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	return self;
#line 291 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            GtkRadioButton* blank_radio)
{
#line 52 "../src/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, blank_radio);
#line 300 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_update_ap (NetworkWifiMenuItem* self)
{
	guint8 strength = 0U;
	GList* _tmp0_;
	GtkLabel* _tmp6_;
	NMAccessPoint* _tmp7_;
	GBytes* _tmp8_;
	gsize _tmp9_ = 0;
	guint8* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp13_;
	NMAccessPoint* _tmp14_;
	gboolean is_secured = FALSE;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
#line 101 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 103 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->ap_list;
#line 330 "WifiMenuItem.c"
	{
		GList* acess_point_collection = NULL;
		GList* acess_point_it = NULL;
#line 103 "../src/Widgets/WifiMenuItem.vala"
		acess_point_collection = _tmp0_;
#line 103 "../src/Widgets/WifiMenuItem.vala"
		for (acess_point_it = acess_point_collection; acess_point_it != NULL; acess_point_it = acess_point_it->next) {
#line 338 "WifiMenuItem.c"
			NMAccessPoint* acess_point = NULL;
#line 103 "../src/Widgets/WifiMenuItem.vala"
			acess_point = (NMAccessPoint*) acess_point_it->data;
#line 342 "WifiMenuItem.c"
			{
				NMAccessPoint* _tmp1_ = NULL;
				NMAccessPoint* _tmp2_;
				NMAccessPoint* _tmp5_;
#line 104 "../src/Widgets/WifiMenuItem.vala"
				_tmp2_ = acess_point;
#line 104 "../src/Widgets/WifiMenuItem.vala"
				if (strength > nm_access_point_get_strength (_tmp2_)) {
#line 351 "WifiMenuItem.c"
					NMAccessPoint* _tmp3_;
#line 104 "../src/Widgets/WifiMenuItem.vala"
					_tmp3_ = self->priv->_ap;
#line 104 "../src/Widgets/WifiMenuItem.vala"
					_tmp1_ = _tmp3_;
#line 357 "WifiMenuItem.c"
				} else {
					NMAccessPoint* _tmp4_;
#line 104 "../src/Widgets/WifiMenuItem.vala"
					_tmp4_ = acess_point;
#line 104 "../src/Widgets/WifiMenuItem.vala"
					_tmp1_ = _tmp4_;
#line 364 "WifiMenuItem.c"
				}
#line 104 "../src/Widgets/WifiMenuItem.vala"
				network_wifi_menu_item_set_ap (self, _tmp1_);
#line 105 "../src/Widgets/WifiMenuItem.vala"
				_tmp5_ = acess_point;
#line 105 "../src/Widgets/WifiMenuItem.vala"
				strength = MAX (strength, nm_access_point_get_strength (_tmp5_));
#line 372 "WifiMenuItem.c"
			}
		}
	}
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = self->priv->label;
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = self->priv->_ap;
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = nm_access_point_get_ssid (_tmp7_);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp10_ = g_bytes_get_data (_tmp8_, &_tmp9_);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp11_ = nm_utils_ssid_to_utf8 (_tmp10_, (gsize) _tmp9_);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp12_ = _tmp11_;
#line 108 "../src/Widgets/WifiMenuItem.vala"
	gtk_label_set_label (_tmp6_, _tmp12_);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp12_);
#line 110 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = self->priv->_ap;
#line 110 "../src/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->_ap;
#line 110 "../src/Widgets/WifiMenuItem.vala"
	flags = nm_access_point_get_wpa_flags (_tmp13_) | nm_access_point_get_rsn_flags (_tmp14_);
#line 111 "../src/Widgets/WifiMenuItem.vala"
	is_secured = FALSE;
#line 112 "../src/Widgets/WifiMenuItem.vala"
	if ((flags & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
#line 113 "../src/Widgets/WifiMenuItem.vala"
		is_secured = TRUE;
#line 114 "../src/Widgets/WifiMenuItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("40/64-bit WEP encrypted"));
#line 406 "WifiMenuItem.c"
	} else {
#line 115 "../src/Widgets/WifiMenuItem.vala"
		if ((flags & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
#line 116 "../src/Widgets/WifiMenuItem.vala"
			is_secured = TRUE;
#line 117 "../src/Widgets/WifiMenuItem.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("104/128-bit WEP encrypted"));
#line 414 "WifiMenuItem.c"
		} else {
#line 118 "../src/Widgets/WifiMenuItem.vala"
			if ((flags & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
#line 119 "../src/Widgets/WifiMenuItem.vala"
				is_secured = TRUE;
#line 120 "../src/Widgets/WifiMenuItem.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("WPA3 encrypted"));
#line 422 "WifiMenuItem.c"
			} else {
#line 121 "../src/Widgets/WifiMenuItem.vala"
				if ((flags & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
#line 122 "../src/Widgets/WifiMenuItem.vala"
					is_secured = TRUE;
#line 123 "../src/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("WPA encrypted"));
#line 430 "WifiMenuItem.c"
				} else {
					gboolean _tmp15_ = FALSE;
#line 124 "../src/Widgets/WifiMenuItem.vala"
					if ((flags & NM_802_11_AP_SEC_KEY_MGMT_OWE) == NM_802_11_AP_SEC_KEY_MGMT_OWE) {
#line 124 "../src/Widgets/WifiMenuItem.vala"
						_tmp15_ = TRUE;
#line 437 "WifiMenuItem.c"
					} else {
#line 125 "../src/Widgets/WifiMenuItem.vala"
						_tmp15_ = (flags & NM_802_11_AP_SEC_KEY_MGMT_OWE_TM) == NM_802_11_AP_SEC_KEY_MGMT_OWE_TM;
#line 441 "WifiMenuItem.c"
					}
#line 124 "../src/Widgets/WifiMenuItem.vala"
					if (_tmp15_) {
#line 126 "../src/Widgets/WifiMenuItem.vala"
						is_secured = TRUE;
#line 127 "../src/Widgets/WifiMenuItem.vala"
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Passwordless encrypted"));
#line 449 "WifiMenuItem.c"
					} else {
#line 128 "../src/Widgets/WifiMenuItem.vala"
						if (flags != NM_802_11_AP_SEC_NONE) {
#line 129 "../src/Widgets/WifiMenuItem.vala"
							is_secured = TRUE;
#line 130 "../src/Widgets/WifiMenuItem.vala"
							gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Encrypted"));
#line 457 "WifiMenuItem.c"
						} else {
#line 132 "../src/Widgets/WifiMenuItem.vala"
							gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Unsecured"));
#line 461 "WifiMenuItem.c"
						}
					}
				}
			}
		}
	}
#line 135 "../src/Widgets/WifiMenuItem.vala"
	_tmp16_ = self->priv->lock_img;
#line 135 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp16_, !is_secured);
#line 136 "../src/Widgets/WifiMenuItem.vala"
	_tmp17_ = self->priv->lock_img;
#line 136 "../src/Widgets/WifiMenuItem.vala"
	_tmp18_ = self->priv->lock_img;
#line 136 "../src/Widgets/WifiMenuItem.vala"
	_tmp19_ = gtk_widget_get_visible ((GtkWidget*) _tmp18_);
#line 136 "../src/Widgets/WifiMenuItem.vala"
	_tmp20_ = _tmp19_;
#line 136 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp17_, !_tmp20_);
#line 482 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkSpinner* _tmp21_;
	NMDeviceState _tmp22_;
#line 140 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = network_wifi_menu_item_get_strength (self);
#line 141 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 141 "../src/Widgets/WifiMenuItem.vala"
	if (((gint) _tmp1_) < 30) {
#line 503 "WifiMenuItem.c"
		GtkImage* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 142 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = self->priv->img_strength;
#line 142 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = g_strdup_printf (NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME, "weak");
#line 142 "../src/Widgets/WifiMenuItem.vala"
		_tmp4_ = _tmp3_;
#line 142 "../src/Widgets/WifiMenuItem.vala"
		g_object_set (_tmp2_, "icon-name", _tmp4_, NULL);
#line 142 "../src/Widgets/WifiMenuItem.vala"
		_g_free0 (_tmp4_);
#line 517 "WifiMenuItem.c"
	} else {
		guint8 _tmp5_;
		guint8 _tmp6_;
#line 143 "../src/Widgets/WifiMenuItem.vala"
		_tmp5_ = network_wifi_menu_item_get_strength (self);
#line 143 "../src/Widgets/WifiMenuItem.vala"
		_tmp6_ = _tmp5_;
#line 143 "../src/Widgets/WifiMenuItem.vala"
		if (((gint) _tmp6_) < 55) {
#line 527 "WifiMenuItem.c"
			GtkImage* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 144 "../src/Widgets/WifiMenuItem.vala"
			_tmp7_ = self->priv->img_strength;
#line 144 "../src/Widgets/WifiMenuItem.vala"
			_tmp8_ = g_strdup_printf (NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME, "ok");
#line 144 "../src/Widgets/WifiMenuItem.vala"
			_tmp9_ = _tmp8_;
#line 144 "../src/Widgets/WifiMenuItem.vala"
			g_object_set (_tmp7_, "icon-name", _tmp9_, NULL);
#line 144 "../src/Widgets/WifiMenuItem.vala"
			_g_free0 (_tmp9_);
#line 541 "WifiMenuItem.c"
		} else {
			guint8 _tmp10_;
			guint8 _tmp11_;
#line 145 "../src/Widgets/WifiMenuItem.vala"
			_tmp10_ = network_wifi_menu_item_get_strength (self);
#line 145 "../src/Widgets/WifiMenuItem.vala"
			_tmp11_ = _tmp10_;
#line 145 "../src/Widgets/WifiMenuItem.vala"
			if (((gint) _tmp11_) < 80) {
#line 551 "WifiMenuItem.c"
				GtkImage* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 146 "../src/Widgets/WifiMenuItem.vala"
				_tmp12_ = self->priv->img_strength;
#line 146 "../src/Widgets/WifiMenuItem.vala"
				_tmp13_ = g_strdup_printf (NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME, "good");
#line 146 "../src/Widgets/WifiMenuItem.vala"
				_tmp14_ = _tmp13_;
#line 146 "../src/Widgets/WifiMenuItem.vala"
				g_object_set (_tmp12_, "icon-name", _tmp14_, NULL);
#line 146 "../src/Widgets/WifiMenuItem.vala"
				_g_free0 (_tmp14_);
#line 565 "WifiMenuItem.c"
			} else {
				GtkImage* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
#line 148 "../src/Widgets/WifiMenuItem.vala"
				_tmp15_ = self->priv->img_strength;
#line 148 "../src/Widgets/WifiMenuItem.vala"
				_tmp16_ = g_strdup_printf (NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME, "excellent");
#line 148 "../src/Widgets/WifiMenuItem.vala"
				_tmp17_ = _tmp16_;
#line 148 "../src/Widgets/WifiMenuItem.vala"
				g_object_set (_tmp15_, "icon-name", _tmp17_, NULL);
#line 148 "../src/Widgets/WifiMenuItem.vala"
				_g_free0 (_tmp17_);
#line 580 "WifiMenuItem.c"
			}
		}
	}
#line 151 "../src/Widgets/WifiMenuItem.vala"
	_tmp18_ = self->priv->error_img;
#line 151 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp18_, TRUE);
#line 152 "../src/Widgets/WifiMenuItem.vala"
	_tmp19_ = self->priv->error_img;
#line 152 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp19_, FALSE);
#line 153 "../src/Widgets/WifiMenuItem.vala"
	_tmp20_ = self->priv->error_img;
#line 153 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_hide ((GtkWidget*) _tmp20_);
#line 155 "../src/Widgets/WifiMenuItem.vala"
	_tmp21_ = self->priv->spinner;
#line 155 "../src/Widgets/WifiMenuItem.vala"
	gtk_spinner_stop (_tmp21_);
#line 157 "../src/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->_state;
#line 157 "../src/Widgets/WifiMenuItem.vala"
	switch (_tmp22_) {
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_FAILED:
#line 606 "WifiMenuItem.c"
		{
			GtkImage* _tmp23_;
			GtkImage* _tmp24_;
#line 159 "../src/Widgets/WifiMenuItem.vala"
			_tmp23_ = self->priv->error_img;
#line 159 "../src/Widgets/WifiMenuItem.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp23_, FALSE);
#line 160 "../src/Widgets/WifiMenuItem.vala"
			_tmp24_ = self->priv->error_img;
#line 160 "../src/Widgets/WifiMenuItem.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp24_, TRUE);
#line 161 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 620 "WifiMenuItem.c"
		}
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_PREPARE:
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_CONFIG:
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_NEED_AUTH:
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_IP_CONFIG:
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_IP_CHECK:
#line 157 "../src/Widgets/WifiMenuItem.vala"
		case NM_DEVICE_STATE_SECONDARIES:
#line 634 "WifiMenuItem.c"
		{
			GtkSpinner* _tmp25_;
			GtkRadioButton* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
#line 168 "../src/Widgets/WifiMenuItem.vala"
			_tmp25_ = self->priv->spinner;
#line 168 "../src/Widgets/WifiMenuItem.vala"
			gtk_spinner_start (_tmp25_);
#line 169 "../src/Widgets/WifiMenuItem.vala"
			_tmp26_ = self->priv->radio_button;
#line 169 "../src/Widgets/WifiMenuItem.vala"
			_tmp27_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp26_);
#line 169 "../src/Widgets/WifiMenuItem.vala"
			_tmp28_ = _tmp27_;
#line 169 "../src/Widgets/WifiMenuItem.vala"
			if (!_tmp28_) {
#line 170 "../src/Widgets/WifiMenuItem.vala"
				g_critical ("WifiMenuItem.vala:170: An access point is being connected but not acti" \
"ve.");
#line 654 "WifiMenuItem.c"
			}
#line 172 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 658 "WifiMenuItem.c"
		}
		default:
		{
#line 174 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 664 "WifiMenuItem.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 179 "../src/Widgets/WifiMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 674 "WifiMenuItem.c"
}

void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	NMAccessPoint* _tmp0_;
#line 178 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (ap != NULL);
#line 179 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = _g_object_ref0 (ap);
#line 179 "../src/Widgets/WifiMenuItem.vala"
	self->priv->ap_list = g_list_append (self->priv->ap_list, _tmp0_);
#line 180 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_ap (self);
#line 181 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 694 "WifiMenuItem.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5185 "glib-2.0.vapi"
	l = self;
#line 5186 "glib-2.0.vapi"
	while (TRUE) {
#line 708 "WifiMenuItem.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5186 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5186 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5186 "glib-2.0.vapi"
			break;
#line 718 "WifiMenuItem.c"
		}
#line 5187 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5187 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5187 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 726 "WifiMenuItem.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5188 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5188 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5188 "glib-2.0.vapi"
			l = _tmp4_;
#line 735 "WifiMenuItem.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5190 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5190 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5190 "glib-2.0.vapi"
			func (_tmp6_);
#line 5191 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5191 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5192 "glib-2.0.vapi"
			break;
#line 752 "WifiMenuItem.c"
		}
	}
#line 5195 "glib-2.0.vapi"
	result = self;
#line 5195 "glib-2.0.vapi"
	return result;
#line 759 "WifiMenuItem.c"
}

gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	GList* _tmp0_;
	gboolean result;
#line 184 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 184 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, FALSE);
#line 185 "../src/Widgets/WifiMenuItem.vala"
	self->priv->ap_list = vala_g_list_remove_full (self->priv->ap_list, ap, _g_object_unref0_);
#line 186 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_ap (self);
#line 187 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->ap_list;
#line 187 "../src/Widgets/WifiMenuItem.vala"
	result = g_list_length (_tmp0_) > ((guint) 0);
#line 187 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 782 "WifiMenuItem.c"
}

NMAccessPoint*
network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self)
{
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_;
#line 19 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 19 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 19 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 798 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_set_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* value)
{
	NMAccessPoint* old_value;
#line 19 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_ap (self);
#line 19 "../src/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 812 "WifiMenuItem.c"
		NMAccessPoint* _tmp0_;
#line 19 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/Widgets/WifiMenuItem.vala"
		_g_object_unref0 (self->priv->_ap);
#line 19 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_ap = _tmp0_;
#line 19 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY]);
#line 822 "WifiMenuItem.c"
	}
}

NMDeviceState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NMDeviceState result;
#line 20 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 20 "../src/Widgets/WifiMenuItem.vala"
	result = self->priv->_state;
#line 20 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 836 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NMDeviceState value)
{
	NMDeviceState old_value;
#line 20 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_state (self);
#line 20 "../src/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 20 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_state = value;
#line 20 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
#line 854 "WifiMenuItem.c"
	}
}

GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	NMAccessPoint* _tmp0_;
	GBytes* _tmp1_;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 24 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
#line 24 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp1_;
#line 24 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 874 "WifiMenuItem.c"
}

guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	guint8 strength = 0U;
	GList* _tmp0_;
#line 29 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 30 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 31 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->ap_list;
#line 889 "WifiMenuItem.c"
	{
		GList* ap_collection = NULL;
		GList* ap_it = NULL;
#line 31 "../src/Widgets/WifiMenuItem.vala"
		ap_collection = _tmp0_;
#line 31 "../src/Widgets/WifiMenuItem.vala"
		for (ap_it = ap_collection; ap_it != NULL; ap_it = ap_it->next) {
#line 897 "WifiMenuItem.c"
			NMAccessPoint* ap = NULL;
#line 31 "../src/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) ap_it->data;
#line 901 "WifiMenuItem.c"
			{
				NMAccessPoint* _tmp1_;
#line 32 "../src/Widgets/WifiMenuItem.vala"
				_tmp1_ = ap;
#line 32 "../src/Widgets/WifiMenuItem.vala"
				strength = MAX (strength, nm_access_point_get_strength (_tmp1_));
#line 908 "WifiMenuItem.c"
			}
		}
	}
#line 34 "../src/Widgets/WifiMenuItem.vala"
	result = strength;
#line 34 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 916 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean value)
{
	GtkRadioButton* _tmp0_;
#line 39 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 40 "../src/Widgets/WifiMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, value);
#line 39 "../src/Widgets/WifiMenuItem.vala"
	g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY]);
#line 932 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_base_init (NetworkWifiMenuItemClass * klass)
{
#line 98 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), GTK_STYLE_CLASS_MENUITEM);
#line 940 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass,
                                   gpointer klass_data)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY] = g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 967 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self,
                                      gpointer klass)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self->priv = network_wifi_menu_item_get_instance_private (self);
#line 20 "../src/Widgets/WifiMenuItem.vala"
	self->priv->_state = NM_DEVICE_STATE_DISCONNECTED;
#line 978 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 19 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_ap);
#line 44 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 45 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 46 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 47 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->label);
#line 48 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 49 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 50 "../src/Widgets/WifiMenuItem.vala"
	(self->priv->ap_list == NULL) ? NULL : (self->priv->ap_list = (_g_list_free__g_object_unref0_ (self->priv->ap_list), NULL));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
#line 1005 "WifiMenuItem.c"
}

static GType
network_wifi_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) network_wifi_menu_item_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
	GType network_wifi_menu_item_type_id;
	network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
	NetworkWifiMenuItem_private_offset = g_type_add_instance_private (network_wifi_menu_item_type_id, sizeof (NetworkWifiMenuItemPrivate));
	return network_wifi_menu_item_type_id;
}

GType
network_wifi_menu_item_get_type (void)
{
	static volatile gsize network_wifi_menu_item_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__once)) {
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = network_wifi_menu_item_get_type_once ();
		g_once_init_leave (&network_wifi_menu_item_type_id__once, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__once;
}

static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1064 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1070 "WifiMenuItem.c"
	}
}

static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_ap (self, g_value_get_object (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_active (self, g_value_get_boolean (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1102 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1108 "WifiMenuItem.c"
	}
}

